/*
 * CoreStationLayout.java
 *
 * Created on 12 maart 2009, 12:21
 */

package nl.astron.lofar.sas.otbcomponents;

import java.awt.Color;
import java.awt.event.ActionEvent;
import org.apache.log4j.Logger;

/**
 *
 * @author  Coolen
 */
public class RemoteStationLayout extends javax.swing.JPanel {
    static Logger logger = Logger.getLogger(RemoteStationLayout.class);
    static String name="RemoteStationLayout";
    
    private boolean HBALeftInnerSquareSelected=false;
    private boolean HBALeftOuterSquareSelected=false;
    private boolean LBAInnerCircleSelected=false;
    private boolean LBAOuterCircleSelected=false;

    /** Creates new form CoreStationLayout */
    public RemoteStationLayout() {
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        LBAOuterCircleText = new javax.swing.JLabel();
        HBALeftInnerSquare = new nl.astron.lofar.sas.otbcomponents.SquareButton();
        HBALeftInnerSquare.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ActionEvent event = new ActionEvent(this,-1,"HBALeftInnerSquare");
                fireActionListenerActionPerformed(event);
            }
        });
        LBAInnerCircle = new nl.astron.lofar.sas.otbcomponents.RoundButton();
        LBAInnerCircle.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ActionEvent event = new ActionEvent(this,-1,"LBAInnerCircle");
                fireActionListenerActionPerformed(event);
            }
        });
        LBAOuterCircle = new nl.astron.lofar.sas.otbcomponents.RoundButton();
        LBAOuterCircle.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ActionEvent event = new ActionEvent(this,-1,"LBAOuterCircle");
                fireActionListenerActionPerformed(event);  }
        });
        HBALeftOuterSquareText = new javax.swing.JLabel();
        HBALeftOuterSquare = new nl.astron.lofar.sas.otbcomponents.SquareButton();
        HBALeftOuterSquare.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ActionEvent event = new ActionEvent(this,-1,"HBALeftOuterSquare");
                fireActionListenerActionPerformed(event);
            }
        });

        setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Remote", javax.swing.border.TitledBorder.CENTER, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 14))); // NOI18N
        setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        LBAOuterCircleText.setFont(new java.awt.Font("Dialog", 1, 12));
        LBAOuterCircleText.setText("48");
        add(LBAOuterCircleText, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 100, -1, 20));

        HBALeftInnerSquare.setText("24");
        HBALeftInnerSquare.setEnabled(false);
        HBALeftInnerSquare.setFont(new java.awt.Font("Dialog", 1, 12));
        add(HBALeftInnerSquare, new org.netbeans.lib.awtextra.AbsoluteConstraints(180, 80, 50, 50));

        LBAInnerCircle.setText("48");
        LBAInnerCircle.setFont(new java.awt.Font("Dialog", 1, 12));
        LBAInnerCircle.setSelected(true);
        add(LBAInnerCircle, new org.netbeans.lib.awtextra.AbsoluteConstraints(40, 80, 50, 50));
        add(LBAOuterCircle, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 50, 110, 110));

        HBALeftOuterSquareText.setFont(new java.awt.Font("Tahoma", 1, 11));
        HBALeftOuterSquareText.setText("24");
        HBALeftOuterSquareText.setEnabled(false);
        add(HBALeftOuterSquareText, new org.netbeans.lib.awtextra.AbsoluteConstraints(160, 100, -1, -1));

        HBALeftOuterSquare.setText("24");
        HBALeftOuterSquare.setEnabled(false);
        HBALeftOuterSquare.setFont(new java.awt.Font("Dialog", 1, 12));
        add(HBALeftOuterSquare, new org.netbeans.lib.awtextra.AbsoluteConstraints(155, 55, 100, 100));
    }// </editor-fold>//GEN-END:initComponents

    /**
     * Notifies all registered listeners about the event.
     *
     * @param event The event to be fired
     */

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private nl.astron.lofar.sas.otbcomponents.SquareButton HBALeftInnerSquare;
    private nl.astron.lofar.sas.otbcomponents.SquareButton HBALeftOuterSquare;
    private javax.swing.JLabel HBALeftOuterSquareText;
    private nl.astron.lofar.sas.otbcomponents.RoundButton LBAInnerCircle;
    private nl.astron.lofar.sas.otbcomponents.RoundButton LBAOuterCircle;
    private javax.swing.JLabel LBAOuterCircleText;
    // End of variables declaration//GEN-END:variables
    /**
     * Utility field used by event firing mechanism.
     */
    private javax.swing.event.EventListenerList myListenerList =  null;

    /**
     * Registers ActionListener to receive events.
     * @param listener The listener to register.
     */
    public synchronized void addActionListener(java.awt.event.ActionListener listener) {
        if (myListenerList == null ) {
            myListenerList = new javax.swing.event.EventListenerList();
        }
        myListenerList.add (java.awt.event.ActionListener.class, listener);
    }

    /**
     * Removes ActionListener from the list of listeners.
     * @param listener The listener to remove.
     */
    public synchronized void removeActionListener(java.awt.event.ActionListener listener) {
        myListenerList.remove (java.awt.event.ActionListener.class, listener);
    }

    /**
     * Notifies all registered listeners about the event.
     * 
     * @param event The event to be fired
     */
    private void fireActionListenerActionPerformed(java.awt.event.ActionEvent event) {

        if (myListenerList == null) return;
        Object[] listeners = myListenerList.getListenerList ();
        for (int i = listeners.length - 2; i >= 0; i -= 2) {
            if (listeners[i]==java.awt.event.ActionListener.class) {
                ((java.awt.event.ActionListener)listeners[i+1]).actionPerformed (event);
            }
        }
    }

    public boolean isHBALeftOuterSquareEnabled() {
        return HBALeftOuterSquare.isEnabled();
    }

    public void setHBALeftOuterSquareEnabled(boolean b) {
        if (!b && HBALeftOuterSquare.isSelected()) {
            setHBALeftOuterSquareSelected(false);
        }
        HBALeftOuterSquare.setEnabled(b);
        HBALeftOuterSquareText.setEnabled(b);
        HBALeftOuterSquare.invalidate();
        HBALeftOuterSquare.repaint();
        
    }

    public boolean isHBALeftInnerSquareEnabled() {
        return HBALeftInnerSquare.isEnabled();
    }

    public void setHBALeftInnerSquareEnabled(boolean b) {
        if (!b && HBALeftInnerSquare.isSelected()) {
            setHBALeftInnerSquareSelected(false);
        }
        HBALeftInnerSquare.setEnabled(b);
        HBALeftInnerSquare.invalidate();
        HBALeftInnerSquare.repaint();
    }

    public boolean isLBAInnerCircleEnabled() {
        return LBAInnerCircle.isEnabled();
    }

    public void setLBAInnerCircleEnabled(boolean b) {
        if (!b && LBAInnerCircle.isSelected()) {
            setLBAInnerCircleSelected(false);
        }
        LBAInnerCircle.setEnabled(b);
        LBAInnerCircle.invalidate();
        LBAInnerCircle.repaint();
    }
    
    public boolean isLBAOuterCircleEnabled() {
        return LBAOuterCircle.isEnabled();
    }

    public void setLBAOuterCircleEnabled(boolean b) {
        if (!b && LBAOuterCircle.isSelected()) {
            setLBAOuterCircleSelected(false);
        }
        LBAOuterCircleText.setEnabled(b);
        LBAOuterCircle.setEnabled(b);
        LBAOuterCircle.invalidate();
        LBAOuterCircle.repaint();
    }

    public boolean isHBALeftOuterSquareSelected() {
        return HBALeftOuterSquareSelected;
    }

    public void setHBALeftOuterSquareSelected(boolean b) {
        HBALeftOuterSquareSelected=b;
        if (b) {
            HBALeftOuterSquare.setBackground(Color.green);
        } else {
            HBALeftOuterSquare.setBackground(getBackground());
        }
        HBALeftOuterSquare.invalidate();
        HBALeftOuterSquare.repaint();
    }

    public boolean isHBALeftInnerSquareSelected() {
        return HBALeftInnerSquareSelected;
    }

    public void setHBALeftInnerSquareSelected(boolean b) {
        HBALeftInnerSquareSelected=b;
        if (b) {
            HBALeftInnerSquare.setBackground(Color.green);
        } else {
            HBALeftInnerSquare.setBackground(getBackground());
        }
        HBALeftInnerSquare.invalidate();
        HBALeftInnerSquare.repaint();
    }

    public boolean isLBAInnerCircleSelected() {
        return LBAInnerCircleSelected;
    }

    public void setLBAInnerCircleSelected(boolean b) {
        LBAInnerCircleSelected=b;
        if (b) {
            LBAInnerCircle.setBackground(Color.green);
        } else {
            LBAInnerCircle.setBackground(getBackground());
        }
        LBAInnerCircle.invalidate();
        LBAInnerCircle.repaint();
    }

    public boolean isLBAOuterCircleSelected() {
        return LBAOuterCircleSelected;
    }

    public void setLBAOuterCircleSelected(boolean b) {
        LBAOuterCircleSelected=b;
        if (b) {
            LBAOuterCircle.setBackground(Color.green);
        } else {
            LBAOuterCircle.setBackground(getBackground());
        }
        LBAOuterCircle.invalidate();
        LBAOuterCircle.repaint();
    
    }
}


