# LOBSTER

**LO**far 2 TMSS **OBS**ervationcontrol con**T**roll**ER** daemon

## Index
- Development

## Development

For prerequisites visit the top level [TMSS readme](SAS/TMSS/README.md)

The following steps will create a python virtual environment setup some folders
and configure the cmake project, built and install it.

```sh
mkdir build_tmss
cd build_tmss
virtualenv -p python3.10 py310
source py310/bin/activate
# Use pip3 install to install dependencies as denoted in
# docker/lofar-ci/Dockerfile_ci_tmss
cmake -DBUILD_PACKAGES=TMSS ../..
make -j $(nproc)
make install -j $(nproc)
```

Once installed the installation can be sourced and a rabbitmq services can be
started

```sh
source installed/lofarinit.sh
docker run -d --hostname ${HOSTNAME} --name lofar-broker -p 5672:5672 -e RABBITMQ_DEFAULT_USER=guest -e RABBITMQ_DEFAULT_PASS=guest rabbitmq:3-management
export LOFAR_DEFAULT_BROKER=${HOSTNAME}
```

Once started Lobster tests can be run using ctest or Python directly

```sh
ctest -VV -R t_l2station_tmss_integration_test
python ../../SAS/TMSS/backend/test/t_l2station_tmss_integration_test.py
```

```sh
ctest -VV -R t_l2station_tmss_test
python ../../SAS/TMSS/backend/test/t_l2station_tmss_test.py
```