# Generated by Django 3.0.9 on 2021-10-07 09:17

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    dependencies = [
        ('tmssapp', '0011_non_null_drafts'),
    ]

    operations = [
        migrations.RunSQL('''CREATE OR REPLACE FUNCTION tmssapp_block_dataproduct_immutable_fields_update()
                      RETURNS trigger AS
                      $BODY$
                      DECLARE
                        dp_producing_subtask_state tmssapp_subtaskstate.value%type;
                      BEGIN
                        SELECT tmssapp_subtask.state_id FROM tmssapp_dataproduct INTO dp_producing_subtask_state
                        INNER JOIN tmssapp_subtaskoutput on tmssapp_subtaskoutput.id=tmssapp_dataproduct.producer_id
                        INNER JOIN tmssapp_subtask on tmssapp_subtask.id=tmssapp_subtaskoutput.subtask_id
                        WHERE tmssapp_dataproduct.id=OLD.id
                        LIMIT 1;

                        IF dp_producing_subtask_state = 'finished' THEN
                          IF OLD.filename <> NEW.filename OR
                             OLD.directory <> NEW.directory OR
                             OLD.size <> NEW.size OR
                             OLD.dataformat_id <> NEW.dataformat_id OR
                             OLD.datatype_id <> NEW.datatype_id OR
                             OLD.specifications_doc <> NEW.specifications_doc OR
                             OLD.specifications_template_id <> NEW.specifications_template_id OR
                             OLD.feedback_doc <> NEW.feedback_doc OR
                             OLD.feedback_template_id <> NEW.feedback_template_id OR
                             OLD.sap_id <> NEW.sap_id OR
                             OLD.global_identifier_id <> NEW.global_identifier_id OR
                             OLD.producer_id <> NEW.producer_id THEN
                            RAISE EXCEPTION 'ILLEGAL UPDATE OF IMMUTABLE DATAPRODUCT FIELD';
                          END IF;
                        END IF;
                      RETURN NEW;
                      END;
                      $BODY$
                      LANGUAGE plpgsql VOLATILE;
                      DROP TRIGGER IF EXISTS tmssapp_block_dataproduct_immutable_fields_update ON tmssapp_dataproduct ;
                      CREATE TRIGGER tmssapp_block_dataproduct_immutable_fields_update
                      BEFORE UPDATE ON tmssapp_dataproduct
                      FOR EACH ROW EXECUTE PROCEDURE tmssapp_block_dataproduct_immutable_fields_update();
                      '''),
        migrations.RunSQL('''CREATE OR REPLACE FUNCTION tmssapp_block_dataproducthash_immutable_fields_update()
                  RETURNS trigger AS
                  $BODY$
                  DECLARE
                    dp_producing_subtask_state tmssapp_subtaskstate.value%type;
                  BEGIN
                    SELECT tmssapp_subtask.state_id FROM tmssapp_dataproducthash INTO dp_producing_subtask_state
                    INNER JOIN tmssapp_dataproduct on tmssapp_dataproduct.id=tmssapp_dataproducthash.dataproduct_id
                    INNER JOIN tmssapp_subtaskoutput on tmssapp_subtaskoutput.id=tmssapp_dataproduct.producer_id
                    INNER JOIN tmssapp_subtask on tmssapp_subtask.id=tmssapp_subtaskoutput.subtask_id
                    WHERE tmssapp_dataproducthash.id=OLD.id
                    LIMIT 1;

                    IF dp_producing_subtask_state = 'finished' THEN
                      IF OLD.hash <> NEW.hash OR
                         OLD.hash_algorithm_id <> NEW.hash_algorithm_id OR
                         OLD.dataproduct_id <> NEW.dataproduct_id THEN
                        RAISE EXCEPTION 'ILLEGAL UPDATE OF IMMUTABLE DATAPRODUCTHASH FIELD';
                      END IF;
                    END IF;
                  RETURN NEW;
                  END;
                  $BODY$
                  LANGUAGE plpgsql VOLATILE;
                  DROP TRIGGER IF EXISTS tmssapp_block_dataproducthash_immutable_fields_update ON tmssapp_dataproducthash ;
                  CREATE TRIGGER tmssapp_block_dataproducthash_immutable_fields_update
                  BEFORE UPDATE ON tmssapp_dataproducthash
                  FOR EACH ROW EXECUTE PROCEDURE tmssapp_block_dataproducthash_immutable_fields_update();
                  '''),
        migrations.RunSQL('''CREATE OR REPLACE FUNCTION tmssapp_block_dataproductarchiveinfo_immutable_fields_update()
              RETURNS trigger AS
              $BODY$
              DECLARE
                dp_producing_subtask_state tmssapp_subtaskstate.value%type;
              BEGIN
                SELECT tmssapp_subtask.state_id FROM tmssapp_dataproductarchiveinfo INTO dp_producing_subtask_state
                INNER JOIN tmssapp_dataproduct on tmssapp_dataproduct.id=tmssapp_dataproductarchiveinfo.dataproduct_id
                INNER JOIN tmssapp_subtaskoutput on tmssapp_subtaskoutput.id=tmssapp_dataproduct.producer_id
                INNER JOIN tmssapp_subtask on tmssapp_subtask.id=tmssapp_subtaskoutput.subtask_id
                WHERE tmssapp_dataproductarchiveinfo.id=OLD.id
                LIMIT 1;

                IF dp_producing_subtask_state = 'finished' THEN
                  IF OLD.storage_ticket <> NEW.storage_ticket OR
                     OLD.dataproduct_id <> NEW.dataproduct_id THEN
                    RAISE EXCEPTION 'ILLEGAL UPDATE OF IMMUTABLE DATAPRODUCTARCHIVEINFO FIELD';
                  END IF;
                END IF;
              RETURN NEW;
              END;
              $BODY$
              LANGUAGE plpgsql VOLATILE;
              DROP TRIGGER IF EXISTS tmssapp_block_dataproductarchiveinfo_immutable_fields_update ON tmssapp_dataproductarchiveinfo ;
              CREATE TRIGGER tmssapp_block_dataproductarchiveinfo_immutable_fields_update
              BEFORE UPDATE ON tmssapp_dataproductarchiveinfo
              FOR EACH ROW EXECUTE PROCEDURE tmssapp_block_dataproductarchiveinfo_immutable_fields_update();
              '''),
        migrations.RunSQL('''CREATE OR REPLACE FUNCTION tmssapp_block_sap_immutable_fields_update()
              RETURNS trigger AS
              $BODY$
              DECLARE
                dp_producing_subtask_state tmssapp_subtaskstate.value%type;
              BEGIN
                SELECT tmssapp_subtask.state_id FROM tmssapp_sap INTO dp_producing_subtask_state
                INNER JOIN tmssapp_dataproduct on tmssapp_dataproduct.sap_id=tmssapp_sap.id
                INNER JOIN tmssapp_subtaskoutput on tmssapp_subtaskoutput.id=tmssapp_dataproduct.producer_id
                INNER JOIN tmssapp_subtask on tmssapp_subtask.id=tmssapp_subtaskoutput.subtask_id
                WHERE tmssapp_sap.id=OLD.id
                LIMIT 1;

                IF dp_producing_subtask_state = 'finished' THEN
                  IF OLD.specifications_doc <> NEW.specifications_doc OR
                     OLD.specifications_template_id <> NEW.specifications_template_id OR
                     OLD.global_identifier_id <> NEW.global_identifier_id THEN
                    RAISE EXCEPTION 'ILLEGAL UPDATE OF IMMUTABLE SAP FIELD';
                  END IF;
                END IF;
              RETURN NEW;
              END;
              $BODY$
              LANGUAGE plpgsql VOLATILE;
              DROP TRIGGER IF EXISTS tmssapp_block_sap_immutable_fields_update ON tmssapp_sap ;
              CREATE TRIGGER tmssapp_block_sap_immutable_fields_update
              BEFORE UPDATE ON tmssapp_sap
              FOR EACH ROW EXECUTE PROCEDURE tmssapp_block_sap_immutable_fields_update();
              ''')
    ]
