# Generated by Django 3.0.9 on 2021-11-01 16:10

import django.contrib.postgres.fields
import django.contrib.postgres.fields.jsonb
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    dependencies = [
        ('tmssapp', '0012_dataproduct_immutable'),
    ]

    operations = [
        migrations.CreateModel(
            name='SubtaskFeedbackTemplate',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('name', models.CharField(help_text='Human-readable name of this object.', max_length=128)),
                ('description', models.CharField(blank=True, default='', help_text='A longer description of this object.', max_length=255)),
                ('version', models.IntegerField(editable=False, help_text='Version of this template (with respect to other templates of the same name)')),
                ('schema', django.contrib.postgres.fields.jsonb.JSONField(help_text='Schema for the configurable parameters needed to use this template.')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.RemoveField(
            model_name='subtask',
            name='actual_on_sky_start_time',
        ),
        migrations.RemoveField(
            model_name='subtask',
            name='actual_on_sky_stop_time',
        ),
        migrations.AddField(
            model_name='subtask',
            name='processing_feedback_doc',
            field=django.contrib.postgres.fields.jsonb.JSONField(help_text='Processing properties, as reported by the process.', null=True),
        ),
        migrations.AddConstraint(
            model_name='subtaskfeedbacktemplate',
            constraint=models.UniqueConstraint(fields=('name', 'version'), name='subtaskfeedbacktemplate_unique_name_version'),
        ),
        migrations.AddField(
            model_name='subtask',
            name='processing_feedback_template',
            field=models.ForeignKey(help_text='Schema used for processing_feedback_doc.', null=True, on_delete=django.db.models.deletion.PROTECT, to='tmssapp.SubtaskFeedbackTemplate'),
        ),
    ]
