# Generated by Django 3.0.9 on 2021-10-07 09:17

from django.db import migrations, models
import django.db.models.deletion

from lofar.sas.tmss.tmss.tmssapp.populate import populate_task_schedulingunit_choices


class Migration(migrations.Migration):

    dependencies = [
        ('tmssapp', '0014_subtask_global_parset_identifier')
    ]

    operations = [
        migrations.CreateModel(
            name='SchedulingUnitStatus',
            fields=[
                ('value', models.CharField(max_length=128, primary_key=True, serialize=False, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='TaskStatus',
            fields=[
                ('value', models.CharField(max_length=128, primary_key=True, serialize=False, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.RunPython(populate_task_schedulingunit_choices),
        migrations.RemoveField(
            model_name='subtask',
            name='scheduled_process_start_time',
        ),
        migrations.RemoveField(
            model_name='subtask',
            name='scheduled_process_stop_time',
        ),
        migrations.AddField(
            model_name='schedulingunitblueprint',
            name='actual_on_sky_start_time',
            field=models.DateTimeField(default=None, editable=False,
                                       help_text='The earliest on sky start time of all observations of this scheduling unit.',
                                       null=True),
        ),
        migrations.AddField(
            model_name='schedulingunitblueprint',
            name='actual_on_sky_stop_time',
            field=models.DateTimeField(default=None, editable=False,
                                       help_text='The latest on sky stop time of all observations of this scheduling unit.',
                                       null=True),
        ),
        migrations.AddField(
            model_name='schedulingunitblueprint',
            name='actual_process_start_time',
            field=models.DateTimeField(default=None, editable=False,
                                       help_text='The earliest actual process start time of all tasks of this scheduling unit.',
                                       null=True),
        ),
        migrations.AddField(
            model_name='schedulingunitblueprint',
            name='actual_process_stop_time',
            field=models.DateTimeField(default=None, editable=False,
                                       help_text='The latest actual process stop time of all tasks of this scheduling unit.',
                                       null=True),
        ),
        migrations.AddField(
            model_name='schedulingunitblueprint',
            name='duration',
            field=models.DurationField(editable=False,
                                       help_text='The scheduled/actual duration for the full task (NULLable).',
                                       null=True),
        ),
        migrations.AddField(
            model_name='schedulingunitblueprint',
            name='observed_duration',
            field=models.DurationField(editable=False,
                                       help_text='The total actual duration that the finished/observed observation tasks were on sky (NULLable).',
                                       null=True),
        ),
        migrations.AddField(
            model_name='schedulingunitblueprint',
            name='observed_start_time',
            field=models.DateTimeField(default=None, editable=False,
                                       help_text='The earliest on_sky_start_time of all the finished/observed observation tasks.',
                                       null=True),
        ),
        migrations.AddField(
            model_name='schedulingunitblueprint',
            name='observed_stop_time',
            field=models.DateTimeField(default=None, editable=False,
                                       help_text='The latest on_sky_stop_time of all the finished/observed observation tasks.',
                                       null=True),
        ),
        migrations.AddField(
            model_name='schedulingunitblueprint',
            name='obsolete_since',
            field=models.DateTimeField(default=None, editable=False,
                                       help_text='When was the first of the subtask(s) marked obsolete, or NULL if not obsolete (NULLable).',
                                       null=True),
        ),
        migrations.AddField(
            model_name='schedulingunitblueprint',
            name='on_sky_duration',
            field=models.DurationField(editable=False,
                                       help_text='The total scheduled/actual duration the observation tasks were on sky (NULLable).',
                                       null=True),
        ),
        migrations.AddField(
            model_name='schedulingunitblueprint',
            name='on_sky_start_time',
            field=models.DateTimeField(default=None, editable=False,
                                       help_text='The earliest on_sky_start_time of all the observation tasks.',
                                       null=True),
        ),
        migrations.AddField(
            model_name='schedulingunitblueprint',
            name='on_sky_stop_time',
            field=models.DateTimeField(default=None, editable=False,
                                       help_text='The latest on_sky_stop_time of all the observation tasks.',
                                       null=True),
        ),
        migrations.AddField(
            model_name='schedulingunitblueprint',
            name='process_start_time',
            field=models.DateTimeField(default=None, editable=False,
                                       help_text='The earliest process_start_time of all the tasks.', null=True),
        ),
        migrations.AddField(
            model_name='schedulingunitblueprint',
            name='process_stop_time',
            field=models.DateTimeField(default=None, editable=False,
                                       help_text='The latest process_stop_time of all the tasks.', null=True),
        ),
        migrations.AddField(
            model_name='schedulingunitblueprint',
            name='scheduled_start_time',
            field=models.DateTimeField(default=None, editable=False,
                                       help_text='The earliest scheduled start time of all tasks of this scheduling unit.',
                                       null=True),
        ),
        migrations.AddField(
            model_name='schedulingunitblueprint',
            name='scheduled_stop_time',
            field=models.DateTimeField(default=None, editable=False,
                                       help_text='The latest scheduled stop time of all tasks of this scheduling unit.',
                                       null=True),
        ),
        migrations.AddField(
            model_name='subtask',
            name='duration',
            field=models.DurationField(editable=False,
                                       help_text='The scheduled/actual duration the subtask ran (NULLable).',
                                       null=True),
        ),
        migrations.AddField(
            model_name='subtask',
            name='on_sky_duration',
            field=models.DurationField(editable=False,
                                       help_text='The scheduled/actual duration the observation was on sky (NULLable).',
                                       null=True),
        ),
        migrations.AddField(
            model_name='subtask',
            name='on_sky_start_time',
            field=models.DateTimeField(editable=False,
                                       help_text='The time the observation actually started receiving data from the sky when actual_on_sky_start_time is known else the scheduled_start_time. Is NULL for non-observations. (NULLable).',
                                       null=True),
        ),
        migrations.AddField(
            model_name='subtask',
            name='on_sky_stop_time',
            field=models.DateTimeField(editable=False,
                                       help_text='The time the observation actually stopped receiving data from the sky when actual_on_sky_stop_time is known else the scheduled_stop_time Is NULL for non-observations. (NULLable).',
                                       null=True),
        ),
        migrations.AddField(
            model_name='subtask',
            name='process_start_time',
            field=models.DateTimeField(editable=False,
                                       help_text='The time the process actually started when actual_process_start_time is known else the scheduled_start_time. (NULLable).',
                                       null=True),
        ),
        migrations.AddField(
            model_name='subtask',
            name='process_stop_time',
            field=models.DateTimeField(editable=False,
                                       help_text='The time the process actually stopped when actual_process_stop_time is known else the scheduled_stop_time (NULLable).',
                                       null=True),
        ),
        migrations.AddField(
            model_name='taskblueprint',
            name='actual_on_sky_start_time',
            field=models.DateTimeField(default=None, editable=False,
                                       help_text='The time the observation actually started recording (NULLable).',
                                       null=True),
        ),
        migrations.AddField(
            model_name='taskblueprint',
            name='actual_on_sky_stop_time',
            field=models.DateTimeField(default=None, editable=False,
                                       help_text='The time the observation actually stopped recording (NULLable).',
                                       null=True),
        ),
        migrations.AddField(
            model_name='taskblueprint',
            name='actual_process_start_time',
            field=models.DateTimeField(default=None, editable=False,
                                       help_text='The time the process actually started (NULLable).', null=True),
        ),
        migrations.AddField(
            model_name='taskblueprint',
            name='actual_process_stop_time',
            field=models.DateTimeField(default=None, editable=False,
                                       help_text='The time the process actually stopped (NULLable).', null=True),
        ),
        migrations.AddField(
            model_name='taskblueprint',
            name='duration',
            field=models.DurationField(editable=False,
                                       help_text='The scheduled/actual duration for the full task (NULLable).',
                                       null=True),
        ),
        migrations.AddField(
            model_name='taskblueprint',
            name='obsolete_since',
            field=models.DateTimeField(default=None, editable=False,
                                       help_text='When was the first of the subtask(s) marked obsolete, or NULL if not obsolete (NULLable).',
                                       null=True),
        ),
        migrations.AddField(
            model_name='taskblueprint',
            name='on_sky_duration',
            field=models.DurationField(editable=False,
                                       help_text='The scheduled/actual duration the observation was on sky (NULLable).',
                                       null=True),
        ),
        migrations.AddField(
            model_name='taskblueprint',
            name='on_sky_start_time',
            field=models.DateTimeField(default=None, editable=False,
                                       help_text='The earliest on_sky_start_time of all the observation subtasks of this task.',
                                       null=True),
        ),
        migrations.AddField(
            model_name='taskblueprint',
            name='on_sky_stop_time',
            field=models.DateTimeField(default=None, editable=False,
                                       help_text='The latest on_sky_stop_time of all the observation subtasks of this task..',
                                       null=True),
        ),
        migrations.AddField(
            model_name='taskblueprint',
            name='process_start_time',
            field=models.DateTimeField(default=None, editable=False,
                                       help_text='The earliest process_start_time of all the subtasks of this task.',
                                       null=True),
        ),
        migrations.AddField(
            model_name='taskblueprint',
            name='process_stop_time',
            field=models.DateTimeField(default=None, editable=False,
                                       help_text='The latest process_stop_time of all the subtasks of this task.',
                                       null=True),
        ),
        migrations.AddField(
            model_name='taskblueprint',
            name='scheduled_start_time',
            field=models.DateTimeField(default=None, editable=False,
                                       help_text='The time we want the task to start (NULLable). For observations that means: the moment the telescope should be receiving data from the sky. For pipelines/others: the moment the subtask should running.',
                                       null=True),
        ),
        migrations.AddField(
            model_name='taskblueprint',
            name='scheduled_stop_time',
            field=models.DateTimeField(default=None, editable=False,
                                       help_text='The time we want the task to stop (NULLable).', null=True),
        ),
        migrations.AddField(
            model_name='subtask',
            name='actual_on_sky_start_time',
            field=models.DateTimeField(
                help_text='The time the observation actually started receiving data from the sky. This should be as close as possible to the scheduled_start_time. Is NULL for non-observations. (NULLable).',
                null=True),
        ),
        migrations.AddField(
            model_name='subtask',
            name='actual_on_sky_stop_time',
            field=models.DateTimeField(
                help_text='The time the observation actually stopped recording Is NULL for non-observations. (NULLable).',
                null=True),
        ),
        migrations.AlterField(
            model_name='subtask',
            name='actual_process_start_time',
            field=models.DateTimeField(
                help_text='The time the process actually started, which can be a bit in advance of the scheduled_start_time depending on which process picks it up, and how much setup time it needs. (NULLable).',
                null=True),
        ),
        migrations.RenameField(
            model_name='subtask',
            old_name='scheduled_on_sky_start_time',
            new_name='scheduled_start_time',
        ),
        migrations.AlterField(
            model_name='subtask',
            name='scheduled_start_time',
            field=models.DateTimeField(
                help_text='The time we want the subtask to start (NULLable). For observations that means: the moment the telescope should be receiving data from the sky. For pipelines/others: the moment the subtask should running.',
                null=True),
        ),
        migrations.RenameField(
            model_name='subtask',
            old_name='scheduled_on_sky_stop_time',
            new_name='scheduled_stop_time',
        ),
        migrations.AlterField(
            model_name='subtask',
            name='scheduled_stop_time',
            field=models.DateTimeField(help_text='The time we want the subtask to stop (NULLable).', null=True),
        ),
        migrations.AddField(
            model_name='schedulingunitblueprint',
            name='status',
            field=models.ForeignKey(default='defined', editable=False,
                                    help_text='The SchedulingUnit status - derived from the combined task statuses.',
                                    on_delete=django.db.models.deletion.PROTECT, to='tmssapp.SchedulingUnitStatus'),
        ),
        migrations.AddField(
            model_name='taskblueprint',
            name='status',
            field=models.ForeignKey(default='defined', editable=False,
                                    help_text='The Task status - derived from the subtask(s) status(es).',
                                    on_delete=django.db.models.deletion.PROTECT, to='tmssapp.TaskStatus'),
        ),
        migrations.RunSQL('''CREATE OR REPLACE FUNCTION tmssapp_block_subtask_immutable_fields_update()
                      RETURNS trigger AS
                      $BODY$
                      BEGIN
                        IF TG_OP = 'UPDATE' THEN
                          IF OLD.specifications_doc <> NEW.specifications_doc OR
                             OLD.specifications_template_id <> NEW.specifications_template_id OR
                             OLD.processing_feedback_doc <> NEW.processing_feedback_doc OR
                             OLD.processing_feedback_template_id <> NEW.processing_feedback_template_id OR
                             OLD.primary <> NEW.primary OR
                             OLD.task_blueprint_id <> NEW.task_blueprint_id OR
                             OLD.cluster_id <> NEW.cluster_id THEN
                            RAISE EXCEPTION 'ILLEGAL UPDATE OF IMMUTABLE SUBTASK FIELD';
                          END IF;

                          IF OLD.actual_process_start_time <> NEW.actual_process_start_time THEN
                              RAISE EXCEPTION 'subtask.actual_process_start_time may only be set once';
                          END IF;

                          IF OLD.actual_process_stop_time <> NEW.actual_process_stop_time THEN
                              RAISE EXCEPTION 'subtask.actual_process_stop_time may only be set once';
                          END IF;
                          
                          IF OLD.actual_on_sky_start_time <> NEW.actual_on_sky_start_time THEN
                              RAISE EXCEPTION 'subtask.actual_on_sky_start_time may only be set once';
                          END IF;

                          IF OLD.actual_on_sky_stop_time <> NEW.actual_on_sky_stop_time THEN
                              RAISE EXCEPTION 'subtask.actual_on_sky_stop_time may only be set once';
                          END IF;
                          
                          IF OLD.error_reason <> NEW.error_reason OR (OLD.error_reason IS NULL AND NEW.error_reason IS NOT NULL) THEN
                            IF OLD.error_reason IS NOT NULL THEN
                              RAISE EXCEPTION 'subtask.error_reason may only be set once';
                            END IF;
                          END IF;

                          IF (OLD.scheduled_start_time <> NEW.scheduled_start_time) OR (OLD.scheduled_stop_time <> NEW.scheduled_stop_time) THEN
                              -- observations can only update scheduled_start_time/scheduled_stop_time while (un)scheduling
                              IF EXISTS(SELECT true FROM tmssapp_subtask INNER JOIN tmssapp_subtasktemplate ON tmssapp_subtasktemplate.id=tmssapp_subtask.specifications_template_id WHERE tmssapp_subtask.id=NEW.id AND tmssapp_subtasktemplate.type_id='observation') THEN   
                                  IF OLD.state_id NOT IN ('defined', 'scheduling', 'unscheduling') THEN
                                      RAISE EXCEPTION 'subtask.scheduled_start_time/scheduled_stop_time cannot be set when state=%', OLD.state_id;
                                  END IF;
                              ELSE
                                  -- pipelines, ingest, etc can also update scheduled_start_time/scheduled_stop_time while scheduled/queued
                                  IF OLD.state_id NOT IN ('defined', 'scheduling', 'unscheduling', 'scheduled', 'queueing', 'queued') THEN
                                      RAISE EXCEPTION 'subtask.scheduled_start_time/scheduled_stop_time cannot be set when state=%', OLD.state_id;
                                  END IF;
                              END IF;
                          END IF;
                        END IF;

                        IF NEW.error_reason IS NOT NULL AND NEW.state_id <> 'error' THEN
                          RAISE EXCEPTION 'subtask.error_reason may only be set when state==error';
                        END IF;
                       
                        IF (NEW.actual_process_start_time IS NOT NULL OR NEW.actual_process_stop_time IS NOT NULL) AND NEW.state_id NOT IN ('starting', 'started', 'finishing', 'finished', 'cancelling', 'cancelled', 'error') THEN
                          RAISE EXCEPTION 'subtask.actual_process_start_time/actual_process_stop_time cannot be set when state=%', NEW.state_id;
                        END IF;

                        IF (NEW.actual_on_sky_start_time IS NOT NULL OR NEW.actual_on_sky_stop_time IS NOT NULL) AND NEW.state_id NOT IN ('started', 'finishing', 'finished', 'cancelling', 'cancelled', 'error') THEN
                          RAISE EXCEPTION 'subtask.actual_on_sky_start_time/actual_on_sky_stop_time cannot be set when state=%', NEW.state_id;
                        END IF;
                      RETURN NEW;
                      END;
                      $BODY$
                      LANGUAGE plpgsql VOLATILE;
                      DROP TRIGGER IF EXISTS tmssapp_block_subtask_immutable_fields_update ON tmssapp_Subtask ;
                      CREATE TRIGGER tmssapp_block_subtask_immutable_fields_update
                      BEFORE UPDATE OR INSERT ON tmssapp_Subtask
                      FOR EACH ROW EXECUTE PROCEDURE tmssapp_block_subtask_immutable_fields_update();
                      '''),
        # Create a view on all start/stop times, statuses and durations for each subtask and task in each schedulingunit
        # This show you a humongous table with many columns which may prove very benificial for support
        migrations.RunSQL(''' CREATE OR REPLACE VIEW public.tmssapp_schedulingunit_task_subtask_status_startstoptimes_view AS
        SELECT subp.id as su_id, tbp.id as task_id, subtask.id as subtask_id, tbp.name as task_name,
subp.status_id as su_status, tbp.status_id as task_status, subtask.state_id as subtask_state,
subp.scheduled_start_time as su_scheduled_start_time, subp.process_start_time as su_process_start_time, subp.actual_process_start_time as su_actual_process_start_time, subp.on_sky_start_time as su_on_sky_start_time, subp.actual_on_sky_start_time as su_actual_on_sky_start_time, subp.observed_start_time as su_observed_start_time, 
tbp.scheduled_start_time as task_scheduled_start_time, tbp.process_start_time as task_process_start_time, tbp.actual_process_start_time as task_actual_process_start_time, tbp.on_sky_start_time as task_on_sky_start_time, tbp.actual_on_sky_start_time as task_actual_on_sky_start_time,
subtask.scheduled_start_time as subtask_scheduled_start_time, subtask.process_start_time as subtask_process_start_time, subtask.actual_process_start_time as subtask_actual_process_start_time, subtask.on_sky_start_time as subtask_on_sky_start_time, subtask.actual_on_sky_start_time as subtask_actual_on_sky_start_time,
subp.scheduled_stop_time as su_scheduled_stop_time, subp.process_stop_time as su_process_stop_time, subp.actual_process_stop_time as su_actual_process_stop_time, subp.on_sky_stop_time as su_on_sky_stop_time, subp.actual_on_sky_stop_time as su_actual_on_sky_stop_time, subp.observed_stop_time as su_observed_stop_time, 
tbp.scheduled_stop_time as task_scheduled_stop_time, tbp.process_stop_time as task_process_stop_time, tbp.actual_process_stop_time as task_actual_process_stop_time, tbp.on_sky_stop_time as task_on_sky_stop_time, tbp.actual_on_sky_stop_time as task_actual_on_sky_stop_time,
subtask.scheduled_stop_time as subtask_scheduled_stop_time, subtask.process_stop_time as subtask_process_stop_time, subtask.actual_process_stop_time as subtask_actual_process_stop_time, subtask.on_sky_stop_time as subtask_on_sky_stop_time, subtask.actual_on_sky_stop_time as subtask_actual_on_sky_stop_time,
subp.duration as su_duration, subp.on_sky_duration as su_on_sky_duration, subp.observed_duration as su_observed_duration, 
tbp.duration as task_duration, tbp.on_sky_duration as task_on_sky_duration,
subtask.duration as subtask_duration, subtask.on_sky_duration as subtask_on_sky_duration
FROM tmssapp_schedulingunitblueprint as subp 
INNER JOIN tmssapp_taskblueprint as tbp ON tbp.scheduling_unit_blueprint_id=subp.id
INNER JOIN tmssapp_subtask as subtask ON subtask.task_blueprint_id=tbp.id
ORDER BY subp.id desc, tbp.id asc, subtask.id asc;
COMMENT ON VIEW public.tmssapp_schedulingunit_task_subtask_status_startstoptimes_view
    IS 'An overview on all schedulingunits and their taskblueprints and subtasks with all status, start/stop times and durations.';
        '''),
        migrations.RunSQL('''CREATE OR REPLACE FUNCTION tmssapp_subtask_compute_aggretates()
              RETURNS trigger AS
              $BODY$
              DECLARE
                subtask_type character varying(128);
              BEGIN
                -- this trigger function runs before the actual row is stored, so we can modify/compute some values  
                -- compute the aggregated on_sky/process start/stop times, based on what is already known

                -- process_start/stop_times are the 'best result' of what happened, or what should happen. (use COALESCE)
                -- in other words, report what we want to happen, or what just happened (while still running).
                IF TG_OP = 'UPDATE' THEN
                    NEW.process_start_time := COALESCE(NEW.actual_process_start_time, NEW.scheduled_start_time, OLD.process_start_time); 
                    NEW.process_stop_time := COALESCE(NEW.actual_process_stop_time, NEW.scheduled_stop_time, OLD.process_stop_time);
                ELSE 
                    NEW.process_start_time := COALESCE(NEW.actual_process_start_time, NEW.scheduled_start_time); 
                    NEW.process_stop_time := COALESCE(NEW.actual_process_stop_time, NEW.scheduled_stop_time);
                END IF;
                
                -- any on_sky time may only be set/computed for observations
                SELECT tmssapp_subtasktemplate.type_id INTO subtask_type 
                FROM tmssapp_subtask 
                INNER JOIN tmssapp_subtasktemplate on tmssapp_subtasktemplate.id=tmssapp_subtask.specifications_template_id
                WHERE tmssapp_subtask.id=NEW.id
                LIMIT 1;
                
                IF subtask_type='observation' THEN
                    -- process_start/stop_times are the 'best result' of what happened, or what should happen. (use COALESCE)
                    -- in other words, report what we want to happen, or what just happened (while still running).
                    IF TG_OP = 'UPDATE' THEN
                        NEW.on_sky_start_time := COALESCE(NEW.actual_on_sky_start_time, NEW.scheduled_start_time, OLD.on_sky_start_time); 
                        NEW.on_sky_stop_time := COALESCE(NEW.actual_on_sky_stop_time, NEW.scheduled_stop_time, OLD.on_sky_stop_time); 
                    ELSE
                        NEW.on_sky_start_time := COALESCE(NEW.actual_on_sky_start_time, NEW.scheduled_start_time); 
                        NEW.on_sky_stop_time := COALESCE(NEW.actual_on_sky_stop_time, NEW.scheduled_stop_time); 
                    END IF;
                ELSE
                    -- erase any user-set on_sky time for non-observations
                    NEW.actual_on_sky_start_time := NULL; 
                    NEW.actual_on_sky_stop_time := NULL; 
                    NEW.on_sky_start_time := NULL; 
                    NEW.on_sky_stop_time := NULL; 
                END IF;

                -- compute the durations using the just computed on_sky/process start/stoptimes
                NEW.duration := AGE(NEW.process_stop_time, NEW.process_start_time); 
                -- on_sky_duration can/should be NULL for non-observations. 
                NEW.on_sky_duration := AGE(NEW.on_sky_stop_time, NEW.on_sky_start_time); 
                
                -- return modified NEW row with aggregated times, which are then stored during the actual insert/update
                RETURN NEW;
              END;
              $BODY$
              LANGUAGE plpgsql VOLATILE;
              DROP TRIGGER IF EXISTS tmssapp_subtask_compute_aggretates ON tmssapp_subtask ;
              CREATE TRIGGER tmssapp_subtask_compute_aggretates
              BEFORE INSERT OR UPDATE ON tmssapp_subtask
              FOR EACH ROW EXECUTE PROCEDURE tmssapp_subtask_compute_aggretates();
              '''),
        migrations.RunSQL('''CREATE OR REPLACE FUNCTION tmssapp_subtask_compute_aggretates_for_taskblueprint()
                 RETURNS trigger AS
                 $BODY$
                 DECLARE
                   agg_scheduled_start_time timestamp with time zone;
                   agg_scheduled_stop_time timestamp with time zone;
                   agg_actual_process_start_time timestamp with time zone;
                   agg_actual_process_stop_time timestamp with time zone;
                   agg_actual_on_sky_start_time timestamp with time zone;
                   agg_actual_on_sky_stop_time timestamp with time zone;
                   agg_process_start_time timestamp with time zone;
                   agg_process_stop_time timestamp with time zone;
                   agg_on_sky_start_time timestamp with time zone;
                   agg_on_sky_stop_time timestamp with time zone;
                   agg_status character varying(128);
                   agg_obsolete_since timestamp with time zone;
                   agg_on_sky_duration interval;
                   agg_duration interval;
                 BEGIN

                       -- aggregate the various timestamps
                       -- consider all the subtasks for this taskblueprint, excluding non-primary obsolete subtasks
                       -- use a WITH Common Table Expression followed by a SELECT INTO variables for speed 
                       WITH subtask_agg AS (SELECT MIN(scheduled_start_time) as scheduled_start_time,
                                                   MAX(scheduled_stop_time) as scheduled_stop_time,
                                                   MIN(actual_process_start_time) as actual_process_start_time,
                                                   MAX(actual_process_stop_time) as actual_process_stop_time,
                                                   MIN(actual_on_sky_start_time) as actual_on_sky_start_time,
                                                   MAX(actual_on_sky_stop_time) as actual_on_sky_stop_time,
                                                   MIN(process_start_time) as process_start_time,
                                                   MAX(process_stop_time) as process_stop_time,
                                                   MIN(on_sky_start_time) as on_sky_start_time,
                                                   MAX(on_sky_stop_time) as on_sky_stop_time,
                                                   MIN(obsolete_since) as obsolete_since
                                                   FROM tmssapp_subtask
                                                   WHERE tmssapp_subtask.task_blueprint_id=NEW.task_blueprint_id
                                                   AND NOT (tmssapp_subtask.primary=false AND tmssapp_subtask.obsolete_since IS NOT NULL))
                       SELECT     scheduled_start_time,      scheduled_stop_time,    actual_process_start_time,     actual_process_stop_time,     actual_on_sky_start_time,     actual_on_sky_stop_time,     on_sky_start_time,     on_sky_stop_time,     process_start_time,     process_stop_time,     on_sky_start_time,     on_sky_stop_time,     obsolete_since
                       INTO   agg_scheduled_start_time, agg_scheduled_stop_time, agg_actual_process_start_time, agg_actual_process_stop_time, agg_actual_on_sky_start_time, agg_actual_on_sky_stop_time, agg_on_sky_start_time, agg_on_sky_stop_time, agg_process_start_time, agg_process_stop_time, agg_on_sky_start_time, agg_on_sky_stop_time, agg_obsolete_since
                       FROM subtask_agg;

                        -- compute the durations using the just computed on_sky/process start/stoptimes
                        agg_on_sky_duration := AGE(agg_on_sky_stop_time, agg_on_sky_start_time); 
                        agg_duration := AGE(agg_process_stop_time, agg_process_start_time); 


                       -- aggregate the subtask statuses into one taskblueprint status 
                       -- See design: https://support.astron.nl/confluence/display/TMSS/Specification+Flow/#SpecificationFlow-TaskBlueprints                       
                       -- consider all the subtasks for this taskblueprint, excluding non-primary obsolete subtasks
                       -- use a WITH Common Table Expression followed by a SELECT INTO variables for speed 
                       WITH subtask_statuses AS (SELECT tmssapp_subtask.state_id, tmssapp_subtasktemplate.type_id
                                                   FROM tmssapp_subtask
                                                   INNER JOIN tmssapp_subtasktemplate on tmssapp_subtasktemplate.id=tmssapp_subtask.specifications_template_id
                                                   WHERE tmssapp_subtask.task_blueprint_id=NEW.task_blueprint_id
                                                   AND NOT (tmssapp_subtask.primary=false AND tmssapp_subtask.obsolete_since IS NOT NULL))
                       SELECT CASE
                           WHEN EXISTS(SELECT true FROM subtask_statuses WHERE state_id='defining') THEN 'defined'
                           WHEN (SELECT COUNT(true) FROM subtask_statuses)=0 THEN 'defined'
                           WHEN (SELECT COUNT(true) FROM subtask_statuses WHERE state_id='finished')=(SELECT COUNT(true) FROM subtask_statuses) THEN 'finished'
                           WHEN EXISTS(SELECT true FROM subtask_statuses WHERE state_id IN ('cancelling', 'cancelled')) THEN 'cancelled'
                           WHEN EXISTS(SELECT true FROM subtask_statuses WHERE state_id='error') THEN 'error'
                           WHEN EXISTS(SELECT true FROM subtask_statuses WHERE type_id='observation' AND state_id IN ('finishing', 'finished')) THEN 'observed'
                           WHEN EXISTS(SELECT true FROM subtask_statuses WHERE state_id IN ('starting','started','queueing','queued','finishing','finished')) THEN 'started'
                           WHEN EXISTS(SELECT true FROM subtask_statuses WHERE state_id='scheduled') THEN 'scheduled'
                           WHEN EXISTS(SELECT true FROM subtask_statuses WHERE state_id='unschedulable') THEN 'unschedulable'
                           ELSE 'schedulable'
                         END
                       INTO agg_status
                       FROM subtask_statuses;

                       -- default when no subtasks available
                       IF agg_status IS NULL THEN
                           agg_status := 'schedulable';
                       END IF;

                       -- all aggregated timestamps and statuses were computed
                       -- now update the referred taskblueprint with these aggregated values  
                       UPDATE tmssapp_taskblueprint
                       SET scheduled_start_time=agg_scheduled_start_time, 
                           scheduled_stop_time=agg_scheduled_stop_time,
                           actual_process_start_time=agg_actual_process_start_time, 
                           actual_process_stop_time=agg_actual_process_stop_time, 
                           actual_on_sky_start_time=agg_actual_on_sky_start_time, 
                           actual_on_sky_stop_time=agg_actual_on_sky_stop_time, 
                           process_start_time=agg_process_start_time, 
                           process_stop_time=agg_process_stop_time, 
                           on_sky_start_time=agg_on_sky_start_time, 
                           on_sky_stop_time=agg_on_sky_stop_time, 
                           status_id=agg_status, 
                           obsolete_since=agg_obsolete_since,
                           on_sky_duration=agg_on_sky_duration,
                           duration=agg_duration
                       WHERE id=NEW.task_blueprint_id;
                   RETURN NEW;
                   END;
                   $BODY$
                   LANGUAGE plpgsql VOLATILE;
                   DROP TRIGGER IF EXISTS tmssapp_subtask_compute_aggretates_for_taskblueprint ON tmssapp_subtask ;
                   CREATE TRIGGER tmssapp_subtask_compute_aggretates_for_taskblueprint
                   AFTER INSERT OR UPDATE ON tmssapp_subtask
                   FOR EACH ROW EXECUTE PROCEDURE tmssapp_subtask_compute_aggretates_for_taskblueprint();
                 '''),
        migrations.RunSQL('''CREATE OR REPLACE FUNCTION tmssapp_taskblueprint_compute_aggretates_for_schedulingunitblueprint()
                 RETURNS trigger AS
                 $BODY$
                 DECLARE
                   agg_scheduled_start_time timestamp with time zone;
                   agg_scheduled_stop_time timestamp with time zone;
                   agg_actual_process_start_time timestamp with time zone;
                   agg_actual_process_stop_time timestamp with time zone;
                   agg_actual_on_sky_start_time timestamp with time zone;
                   agg_actual_on_sky_stop_time timestamp with time zone;
                   agg_process_start_time timestamp with time zone;
                   agg_process_stop_time timestamp with time zone;
                   agg_on_sky_start_time timestamp with time zone;
                   agg_on_sky_stop_time timestamp with time zone;
                   agg_observed_start_time timestamp with time zone;
                   agg_observed_stop_time timestamp with time zone;
                   agg_status character varying(128);
                   agg_obsolete_since timestamp with time zone;
                   agg_on_sky_duration interval;
                   agg_observed_duration interval;
                   agg_duration interval;
                 BEGIN

                       -- aggregate the various timestamps
                       -- consider all the tasks for this schedulingunitblueprint
                       -- use a WITH Common Table Expression followed by a SELECT INTO variables for speed 
                       WITH task_agg AS (SELECT MIN(scheduled_start_time) as scheduled_start_time,
                                                MAX(scheduled_stop_time) as scheduled_stop_time,
                                                MIN(actual_process_start_time) as actual_process_start_time,
                                                MAX(actual_process_stop_time) as actual_process_stop_time,
                                                SUM(duration) as duration,
                                                MIN(actual_on_sky_start_time) as actual_on_sky_start_time,
                                                MAX(actual_on_sky_stop_time) as actual_on_sky_stop_time,
                                                MIN(process_start_time) as process_start_time,
                                                MAX(process_stop_time) as process_stop_time,
                                                MIN(on_sky_start_time) as on_sky_start_time,
                                                MAX(on_sky_stop_time) as on_sky_stop_time,
                                                SUM(on_sky_duration) as on_sky_duration,
                                                MIN(obsolete_since) as obsolete_since
                                                FROM tmssapp_taskblueprint
                                                WHERE tmssapp_taskblueprint.scheduling_unit_blueprint_id=NEW.scheduling_unit_blueprint_id)
                       SELECT     scheduled_start_time,      scheduled_stop_time,    actual_process_start_time,     actual_process_stop_time,     actual_on_sky_start_time,     actual_on_sky_stop_time,     on_sky_start_time,     on_sky_stop_time,     process_start_time,     process_stop_time,     on_sky_start_time,     on_sky_stop_time,     obsolete_since,     duration,     on_sky_duration
                       INTO   agg_scheduled_start_time, agg_scheduled_stop_time, agg_actual_process_start_time, agg_actual_process_stop_time, agg_actual_on_sky_start_time, agg_actual_on_sky_stop_time, agg_on_sky_start_time, agg_on_sky_stop_time, agg_process_start_time, agg_process_stop_time, agg_on_sky_start_time, agg_on_sky_stop_time, agg_obsolete_since, agg_duration, agg_on_sky_duration
                       FROM task_agg;

                       -- compute observed_start/stop_time observerd_duration. These are derived from finished/observed tasks only.
                       -- use a WITH Common Table Expression followed by a SELECT INTO variables for speed 
                       WITH observed_task_agg AS (SELECT MIN(on_sky_start_time) as observed_start_time,
                                                         MAX(on_sky_stop_time) as observed_stop_time,
                                                         SUM(on_sky_duration) as observed_duration
                                                         FROM tmssapp_taskblueprint
                                                         WHERE tmssapp_taskblueprint.scheduling_unit_blueprint_id=NEW.scheduling_unit_blueprint_id
                                                         AND tmssapp_taskblueprint.status_id in ('observed', 'finished'))
                       SELECT     observed_start_time,     observed_stop_time,     observed_duration
                       INTO   agg_observed_start_time, agg_observed_stop_time, agg_observed_duration
                       FROM observed_task_agg;

                       -- aggregate the task statuses into one schedulingunit status 
                       -- See design: https://support.astron.nl/confluence/display/TMSS/Specification+Flow/#SpecificationFlow-SchedulingUnitBlueprints                       
                       -- consider all the taskblueprints for this schedulingunitblueprint
                       -- use a WITH Common Table Expression followed by a SELECT INTO variables for speed 
                       WITH task_statuses AS (SELECT tmssapp_taskblueprint.status_id, tmssapp_tasktemplate.type_id
                                              FROM tmssapp_taskblueprint
                                              INNER JOIN tmssapp_tasktemplate on tmssapp_tasktemplate.id=tmssapp_taskblueprint.specifications_template_id
                                              WHERE tmssapp_taskblueprint.scheduling_unit_blueprint_id=NEW.scheduling_unit_blueprint_id)
                       SELECT CASE
                           WHEN (SELECT COUNT(true) FROM task_statuses)=0 THEN 'defined'
                           WHEN EXISTS(SELECT true FROM task_statuses WHERE status_id='defined') THEN 'defined'
                           WHEN (SELECT COUNT(true) FROM task_statuses WHERE status_id in ('finished', 'observed'))=(SELECT COUNT(true) FROM task_statuses) THEN 'finished'
                           WHEN EXISTS(SELECT true FROM task_statuses WHERE status_id='cancelled') THEN 'cancelled'
                           WHEN EXISTS(SELECT true FROM task_statuses WHERE status_id='error') THEN 'error'
                           WHEN EXISTS(SELECT true FROM task_statuses WHERE status_id='unschedulable') THEN 'unschedulable'
                           WHEN EXISTS(SELECT true FROM task_statuses WHERE status_id IN ('started', 'observed', 'finished')) THEN 
                               CASE
                                   WHEN (SELECT COUNT(true) FROM task_statuses WHERE type_id='observation' AND status_id IN ('observed', 'finished'))<(SELECT COUNT(true) FROM task_statuses WHERE type_id='observation') THEN 'observing'
                                   WHEN NOT EXISTS(SELECT true FROM task_statuses WHERE type_id='pipeline' AND status_id IN ('started', 'finished')) THEN 'observed'
                                   WHEN EXISTS(SELECT true FROM task_statuses WHERE type_id='ingest' AND status_id='started') THEN 'ingesting'
                                   WHEN (SELECT COUNT(true) FROM task_statuses WHERE type_id='pipeline' AND status_id='finished')=(SELECT COUNT(true) FROM task_statuses WHERE type_id='pipeline') THEN 'processed'
                                   WHEN EXISTS(SELECT true FROM task_statuses WHERE type_id='pipeline' AND status_id IN ('started', 'scheduled', 'finished')) THEN 'processing'
                                   WHEN (SELECT COUNT(true) FROM task_statuses WHERE type_id='ingest' AND status_id='finished')=(SELECT COUNT(true) FROM task_statuses WHERE type_id='ingest') THEN 'ingested'
                               END                            
                           WHEN EXISTS(SELECT true FROM task_statuses WHERE status_id='scheduled') THEN 'scheduled'
                         END
                       INTO agg_status
                       FROM task_statuses;

                       -- default when no tasks available
                       IF agg_status IS NULL THEN
                           agg_status := 'schedulable';
                       END IF;

                       -- all aggregated timestamps and statuses were computed
                       -- now update the referred taskblueprint with these aggregated values  
                       UPDATE tmssapp_schedulingunitblueprint
                       SET scheduled_start_time=agg_scheduled_start_time, 
                           scheduled_stop_time=agg_scheduled_stop_time,
                           actual_process_start_time=agg_actual_process_start_time, 
                           actual_process_stop_time=agg_actual_process_stop_time, 
                           actual_on_sky_start_time=agg_actual_on_sky_start_time, 
                           actual_on_sky_stop_time=agg_actual_on_sky_stop_time, 
                           process_start_time=agg_process_start_time, 
                           process_stop_time=agg_process_stop_time, 
                           on_sky_start_time=agg_on_sky_start_time, 
                           on_sky_stop_time=agg_on_sky_stop_time, 
                           observed_start_time=agg_observed_start_time, 
                           observed_stop_time=agg_observed_stop_time, 
                           status_id=agg_status, 
                           obsolete_since=agg_obsolete_since,
                           on_sky_duration=agg_on_sky_duration,
                           observed_duration=agg_observed_duration,
                           duration=agg_duration
                       WHERE id=NEW.scheduling_unit_blueprint_id;
                   RETURN NEW;
                   END;
                   $BODY$
                   LANGUAGE plpgsql VOLATILE;
                   DROP TRIGGER IF EXISTS tmssapp_taskblueprint_compute_aggretates_for_schedulingunitblueprint ON tmssapp_taskblueprint ;
                   CREATE TRIGGER tmssapp_taskblueprint_compute_aggretates_for_schedulingunitblueprint
                   AFTER INSERT OR UPDATE ON tmssapp_taskblueprint
                   FOR EACH ROW EXECUTE PROCEDURE tmssapp_taskblueprint_compute_aggretates_for_schedulingunitblueprint();
                 ''')
    ]
