# Generated by Django 3.0.9 on 2021-11-02 14:54

import django.contrib.postgres.fields
import django.core.validators
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    dependencies = [
        ('tmssapp', '0017_populate_subtask_allowed_state_transitions_extra2'),
    ]

    operations = [
        migrations.CreateModel(
            name='SchedulingConstraintsWeightFactor',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('constraint_name', models.CharField(help_text='for which constraint in the <scheduling_constraints_template> does this weight apply', max_length=128)),
                ('weight', models.FloatField(default=1.0, help_text='Weight factor applied to the normalized scheduling_constraint with the <constraint_name> in <scheduling_constraints_template> for each scheduling unit while doing dynamic scheduling', validators=[django.core.validators.MinValueValidator(0.0), django.core.validators.MaxValueValidator(1.0)])),
                ('scheduling_constraints_template', models.ForeignKey(help_text='for which scheduling_constraints_template does this weight apply', on_delete=django.db.models.deletion.PROTECT, to='tmssapp.SchedulingConstraintsTemplate')),
            ],
        ),
        migrations.AddConstraint(
            model_name='schedulingconstraintsweightfactor',
            constraint=models.UniqueConstraint(fields=('scheduling_constraints_template', 'constraint_name'), name='SchedulingConstraintsWeightFactor_unique_constraint_name_in_scheduling_constraints_template'),
        ),
    ]
