from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    dependencies = [
        ('tmssapp', '0018_schedulingconstraintsweightfactor'),
    ]

    operations = [
        # use database triggers to block updates on blueprint tables for immutable fields
        # this one overrides the trigger from 0002_populate
        migrations.RunSQL('''CREATE OR REPLACE FUNCTION tmssapp_block_scheduling_unit_blueprint_immutable_fields_update()
                          RETURNS trigger AS
                          $BODY$
                          BEGIN
                            IF OLD.specifications_template_id <> NEW.specifications_template_id OR
                               OLD.name <> NEW.name OR
                               OLD.description <> NEW.description THEN
                              RAISE EXCEPTION 'ILLEGAL UPDATE OF IMMUTABLE BLUEPRINT FIELD';
                            END IF;
                            IF (OLD.scheduling_constraints_template_id <> NEW.scheduling_constraints_template_id OR
                                OLD.scheduling_constraints_doc <> NEW.scheduling_constraints_doc) AND
                                OLD.status_id NOT IN ('defined', 'schedulable', 'unschedulable', 'scheduled') THEN
                              RAISE EXCEPTION 'ILLEGAL UPDATE OF IMMUTABLE scheduling_constraints FIELD for status=%', OLD.status_id;
                            END IF;
                          RETURN NEW;
                          END;
                          $BODY$
                          LANGUAGE plpgsql VOLATILE;
                          DROP TRIGGER IF EXISTS tmssapp_block_scheduling_unit_blueprint_immutable_fields_update ON tmssapp_SchedulingUnitBlueprint ;
                          CREATE TRIGGER tmssapp_block_scheduling_unit_blueprint_immutable_fields_update
                          BEFORE UPDATE ON tmssapp_SchedulingUnitBlueprint
                          FOR EACH ROW EXECUTE PROCEDURE tmssapp_block_scheduling_unit_blueprint_immutable_fields_update();
                          '''),
    ]
