# Generated by Django 3.0.9 on 2021-10-07 09:17

from django.db import migrations, models
import django.db.models.deletion

from lofar.sas.tmss.tmss.tmssapp.populate import populate_task_schedulingunit_choices


class Migration(migrations.Migration):

    dependencies = [
        ('tmssapp', '0020_task_queued_status')
    ]

    operations = [
        migrations.RunSQL('''CREATE OR REPLACE FUNCTION tmssapp_block_subtask_immutable_fields_update()
                      RETURNS trigger AS
                      $BODY$
                      BEGIN
                        IF TG_OP = 'UPDATE' THEN
                          IF OLD.specifications_template_id <> NEW.specifications_template_id OR
                             OLD.processing_feedback_doc <> NEW.processing_feedback_doc OR
                             OLD.processing_feedback_template_id <> NEW.processing_feedback_template_id OR
                             OLD.primary <> NEW.primary OR
                             OLD.task_blueprint_id <> NEW.task_blueprint_id OR
                             OLD.cluster_id <> NEW.cluster_id THEN
                            RAISE EXCEPTION 'ILLEGAL UPDATE OF IMMUTABLE SUBTASK FIELD';
                          END IF;

                          IF OLD.specifications_doc <> NEW.specifications_doc THEN
                            IF OLD.state_id NOT IN ('defined', 'scheduling', 'unscheduling') THEN
                              RAISE EXCEPTION 'ILLEGAL UPDATE OF IMMUTABLE SUBTASK FIELD specifications_doc. state=%', OLD.state_id;
                            END IF;
                          END IF;

                          IF OLD.actual_process_start_time <> NEW.actual_process_start_time THEN
                              RAISE EXCEPTION 'subtask.actual_process_start_time may only be set once';
                          END IF;

                          IF OLD.actual_process_stop_time <> NEW.actual_process_stop_time THEN
                              RAISE EXCEPTION 'subtask.actual_process_stop_time may only be set once';
                          END IF;
                          
                          IF OLD.actual_on_sky_start_time <> NEW.actual_on_sky_start_time THEN
                              RAISE EXCEPTION 'subtask.actual_on_sky_start_time may only be set once';
                          END IF;

                          IF OLD.actual_on_sky_stop_time <> NEW.actual_on_sky_stop_time THEN
                              RAISE EXCEPTION 'subtask.actual_on_sky_stop_time may only be set once';
                          END IF;
                          
                          IF OLD.error_reason <> NEW.error_reason OR (OLD.error_reason IS NULL AND NEW.error_reason IS NOT NULL) THEN
                            IF OLD.error_reason IS NOT NULL THEN
                              RAISE EXCEPTION 'subtask.error_reason may only be set once';
                            END IF;
                          END IF;

                          IF (OLD.scheduled_start_time <> NEW.scheduled_start_time) OR (OLD.scheduled_stop_time <> NEW.scheduled_stop_time) THEN
                              -- observations can only update scheduled_start_time/scheduled_stop_time while (un)scheduling
                              IF EXISTS(SELECT true FROM tmssapp_subtask INNER JOIN tmssapp_subtasktemplate ON tmssapp_subtasktemplate.id=tmssapp_subtask.specifications_template_id WHERE tmssapp_subtask.id=NEW.id AND tmssapp_subtasktemplate.type_id='observation') THEN   
                                  IF OLD.state_id NOT IN ('defined', 'scheduling', 'unscheduling') THEN
                                      RAISE EXCEPTION 'subtask.scheduled_start_time/scheduled_stop_time cannot be set when state=%', OLD.state_id;
                                  END IF;
                              ELSE
                                  -- pipelines, ingest, etc can also update scheduled_start_time/scheduled_stop_time while scheduled/queued
                                  IF OLD.state_id NOT IN ('defined', 'scheduling', 'unscheduling', 'scheduled', 'queueing', 'queued') THEN
                                      RAISE EXCEPTION 'subtask.scheduled_start_time/scheduled_stop_time cannot be set when state=%', OLD.state_id;
                                  END IF;
                              END IF;
                          END IF;
                        END IF;

                        IF NEW.error_reason IS NOT NULL AND NEW.state_id <> 'error' THEN
                          RAISE EXCEPTION 'subtask.error_reason may only be set when state==error';
                        END IF;
                       
                        IF (NEW.actual_process_start_time IS NOT NULL OR NEW.actual_process_stop_time IS NOT NULL) AND NEW.state_id NOT IN ('starting', 'started', 'finishing', 'finished', 'cancelling', 'cancelled', 'error') THEN
                          RAISE EXCEPTION 'subtask.actual_process_start_time/actual_process_stop_time cannot be set when state=%', NEW.state_id;
                        END IF;

                        IF (NEW.actual_on_sky_start_time IS NOT NULL OR NEW.actual_on_sky_stop_time IS NOT NULL) AND NEW.state_id NOT IN ('started', 'finishing', 'finished', 'cancelling', 'cancelled', 'error') THEN
                          RAISE EXCEPTION 'subtask.actual_on_sky_start_time/actual_on_sky_stop_time cannot be set when state=%', NEW.state_id;
                        END IF;
                      RETURN NEW;
                      END;
                      $BODY$
                      LANGUAGE plpgsql VOLATILE;
                      DROP TRIGGER IF EXISTS tmssapp_block_subtask_immutable_fields_update ON tmssapp_Subtask ;
                      CREATE TRIGGER tmssapp_block_subtask_immutable_fields_update
                      BEFORE UPDATE OR INSERT ON tmssapp_Subtask
                      FOR EACH ROW EXECUTE PROCEDURE tmssapp_block_subtask_immutable_fields_update();
                      '''),
    ]
