# Generated by Django 3.0.9 on 2022-02-10 15:00

from django.db import migrations, models


class Migration(migrations.Migration):

    dependencies = [
        ('tmssapp', '0024_patches'),
    ]

    operations = [
        migrations.AddField(
            model_name='subtask',
            name='unschedulable_reason',
            field=models.CharField(help_text='Reason why the Subtask is unschedulable. Is automatically reset when status is no longer unschedulable.', max_length=200, null=True, editable=False),
        ),
        migrations.RunSQL('''CREATE OR REPLACE FUNCTION tmssapp_subtask_unschedulable_reason_update()
                  RETURNS trigger AS
                  $BODY$
                  BEGIN
                    IF NEW.unschedulable_reason IS NOT NULL AND NEW.state_id <> 'unschedulable' THEN
                      IF (TG_OP = 'UPDATE' AND OLD.unschedulable_reason <> NEW.unschedulable_reason) OR TG_OP = 'INSERT' THEN
                          RAISE EXCEPTION 'subtask.unschedulable_reason may only be set when state==unschedulable';
                        END IF;
                    END IF;

                    IF TG_OP = 'UPDATE' AND OLD.state_id = 'unschedulable' AND NEW.state_id <> OLD.state_id THEN
                      -- auto-wipe unschedulable_reason when transitioning from state unschedulable 
                      NEW.unschedulable_reason := NULL;
                    END IF;
                  RETURN NEW;
                  END;
                  $BODY$
                  LANGUAGE plpgsql VOLATILE;
                  DROP TRIGGER IF EXISTS tmssapp_subtask_unschedulable_reason_update ON tmssapp_Subtask ;
                  CREATE TRIGGER tmssapp_subtask_unschedulable_reason_update
                  BEFORE UPDATE OR INSERT ON tmssapp_Subtask
                  FOR EACH ROW EXECUTE PROCEDURE tmssapp_subtask_unschedulable_reason_update();
                  ''')
    ]
