# Generated by Django 3.0.9 on 2022-02-11 15:59

import django.contrib.postgres.indexes
from django.db import migrations, models
from lofar.sas.tmss.tmss.tmssapp.populate import populate_projects


class Migration(migrations.Migration):

    dependencies = [
        ('tmssapp', '0025_unschedulable_reason'),
    ]

    operations = [
        migrations.RemoveField(
            model_name='project',
            name='priority_rank',
        ),
        migrations.RemoveField(
            model_name='schedulingunitblueprint',
            name='priority_rank',
        ),
        migrations.RemoveField(
            model_name='schedulingunitdraft',
            name='priority_rank',
        ),
        migrations.AddField(
            model_name='project',
            name='rank',
            field=models.IntegerField(default=4, help_text='Rank of this project (lower values are more important)'),
        ),
        migrations.AddField(
            model_name='schedulingunitblueprint',
            name='rank',
            field=models.FloatField(default=1.0, help_text='Rank of this scheduling unit (lower value is more important when detemining dynamic schedule).'),
        ),
        migrations.AddField(
            model_name='schedulingunitdraft',
            name='rank',
            field=models.FloatField(default=1.0, help_text='Rank of this scheduling unit (lower value is more important when detemining dynamic schedule).'),
        ),
        migrations.AlterField(
            model_name='project',
            name='trigger_priority',
            field=models.IntegerField(default=1000, help_text='Priority of this project w.r.t. triggers. (higher value means more important when dynamic scheduling)'),
        ),
        migrations.AddIndex(
            model_name='schedulingconstraintsweightfactor',
            index=django.contrib.postgres.indexes.GinIndex(fields=['tags'], name='tmssapp_sch_tags_dfd107_gin'),
        ),
        migrations.AddConstraint(
            model_name='project',
            constraint=models.CheckConstraint(check=models.Q(('rank__gte', 0), ('rank__lte', 6)), name='project_rank_range_constraint'),
        ),
        migrations.AddConstraint(
            model_name='project',
            constraint=models.CheckConstraint(check=models.Q(('trigger_priority__gte', 0), ('trigger_priority__lte', 10000)), name='project_trigger_priority_range_constraint'),
        ),
        migrations.AddConstraint(
            model_name='schedulingunitblueprint',
            constraint=models.CheckConstraint(check=models.Q(('rank__gte', 0.0), ('rank__lte', 1.0)), name='schedulingunitblueprint_rank_range_constraint'),
        ),
        migrations.AddConstraint(
            model_name='schedulingunitdraft',
            constraint=models.CheckConstraint(check=models.Q(('rank__gte', 0.0), ('rank__lte', 1.0)), name='schedulingunitdraft_rank_range_constraint'),
        ),
        migrations.RunPython(populate_projects)
    ]
