# Generated by Django 3.0.9 on 2022-02-15 11:23

from django.db import migrations, models
from django.db.models.deletion import PROTECT
from lofar.sas.tmss.tmss.tmssapp.populate import populate_choices_template_state_purpose


class Migration(migrations.Migration):

    dependencies = [
        ('tmssapp', '0026_ranks'),
    ]

    operations = [
        migrations.CreateModel(
            name='TemplatePurpose',
            fields=[
                ('value', models.CharField(max_length=128, primary_key=True, serialize=False, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='TemplateState',
            fields=[
                ('value', models.CharField(max_length=128, primary_key=True, serialize=False, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.RunPython(populate_choices_template_state_purpose),
        migrations.AddField(
            model_name='commonschematemplate',
            name='purpose',
            field=models.ForeignKey(default='technical_commissioning',
                                    help_text='The purpose of this template: Production: offered to the user for cycle and DDT observations. - Scientific Commissioning: scientific/astronomical commissioning. - Technical Commissioning: technical/system commissioning. - System Health: system health monitoring.',
                                    on_delete=PROTECT, to='tmssapp.TemplatePurpose'),
        ),
        migrations.AddField(
            model_name='commonschematemplate',
            name='state',
            field=models.ForeignKey(default='development',
                                    help_text='The state of this template: Development: Strategy under construction. - Active: Available for observing. - Legacy: not offered, but still working. Obsolete: broken or succeeded by newer definitions.',
                                    on_delete=PROTECT, to='tmssapp.TemplateState'),
        ),
        migrations.AddField(
            model_name='dataproductfeedbacktemplate',
            name='purpose',
            field=models.ForeignKey(default='technical_commissioning',
                                    help_text='The purpose of this template: Production: offered to the user for cycle and DDT observations. - Scientific Commissioning: scientific/astronomical commissioning. - Technical Commissioning: technical/system commissioning. - System Health: system health monitoring.',
                                    on_delete=PROTECT, to='tmssapp.TemplatePurpose'),
        ),
        migrations.AddField(
            model_name='dataproductfeedbacktemplate',
            name='state',
            field=models.ForeignKey(default='development',
                                    help_text='The state of this template: Development: Strategy under construction. - Active: Available for observing. - Legacy: not offered, but still working. Obsolete: broken or succeeded by newer definitions.',
                                    on_delete=PROTECT, to='tmssapp.TemplateState'),
        ),
        migrations.AddField(
            model_name='dataproductspecificationstemplate',
            name='purpose',
            field=models.ForeignKey(default='technical_commissioning',
                                    help_text='The purpose of this template: Production: offered to the user for cycle and DDT observations. - Scientific Commissioning: scientific/astronomical commissioning. - Technical Commissioning: technical/system commissioning. - System Health: system health monitoring.',
                                    on_delete=PROTECT, to='tmssapp.TemplatePurpose'),
        ),
        migrations.AddField(
            model_name='dataproductspecificationstemplate',
            name='state',
            field=models.ForeignKey(default='development',
                                    help_text='The state of this template: Development: Strategy under construction. - Active: Available for observing. - Legacy: not offered, but still working. Obsolete: broken or succeeded by newer definitions.',
                                    on_delete=PROTECT, to='tmssapp.TemplateState'),
        ),
        migrations.AddField(
            model_name='reservationtemplate',
            name='purpose',
            field=models.ForeignKey(default='technical_commissioning',
                                    help_text='The purpose of this template: Production: offered to the user for cycle and DDT observations. - Scientific Commissioning: scientific/astronomical commissioning. - Technical Commissioning: technical/system commissioning. - System Health: system health monitoring.',
                                    on_delete=PROTECT, to='tmssapp.TemplatePurpose'),
        ),
        migrations.AddField(
            model_name='reservationtemplate',
            name='state',
            field=models.ForeignKey(default='development',
                                    help_text='The state of this template: Development: Strategy under construction. - Active: Available for observing. - Legacy: not offered, but still working. Obsolete: broken or succeeded by newer definitions.',
                                    on_delete=PROTECT, to='tmssapp.TemplateState'),
        ),
        migrations.AddField(
            model_name='saptemplate',
            name='purpose',
            field=models.ForeignKey(default='technical_commissioning',
                                    help_text='The purpose of this template: Production: offered to the user for cycle and DDT observations. - Scientific Commissioning: scientific/astronomical commissioning. - Technical Commissioning: technical/system commissioning. - System Health: system health monitoring.',
                                    on_delete=PROTECT, to='tmssapp.TemplatePurpose'),
        ),
        migrations.AddField(
            model_name='saptemplate',
            name='state',
            field=models.ForeignKey(default='development',
                                    help_text='The state of this template: Development: Strategy under construction. - Active: Available for observing. - Legacy: not offered, but still working. Obsolete: broken or succeeded by newer definitions.',
                                    on_delete=PROTECT, to='tmssapp.TemplateState'),
        ),
        migrations.AddField(
            model_name='schedulingconstraintstemplate',
            name='purpose',
            field=models.ForeignKey(default='technical_commissioning',
                                    help_text='The purpose of this template: Production: offered to the user for cycle and DDT observations. - Scientific Commissioning: scientific/astronomical commissioning. - Technical Commissioning: technical/system commissioning. - System Health: system health monitoring.',
                                    on_delete=PROTECT, to='tmssapp.TemplatePurpose'),
        ),
        migrations.AddField(
            model_name='schedulingconstraintstemplate',
            name='state',
            field=models.ForeignKey(default='development',
                                    help_text='The state of this template: Development: Strategy under construction. - Active: Available for observing. - Legacy: not offered, but still working. Obsolete: broken or succeeded by newer definitions.',
                                    on_delete=PROTECT, to='tmssapp.TemplateState'),
        ),
        migrations.AddField(
            model_name='schedulingsettemplate',
            name='purpose',
            field=models.ForeignKey(default='technical_commissioning',
                                    help_text='The purpose of this template: Production: offered to the user for cycle and DDT observations. - Scientific Commissioning: scientific/astronomical commissioning. - Technical Commissioning: technical/system commissioning. - System Health: system health monitoring.',
                                    on_delete=PROTECT, to='tmssapp.TemplatePurpose'),
        ),
        migrations.AddField(
            model_name='schedulingsettemplate',
            name='state',
            field=models.ForeignKey(default='development',
                                    help_text='The state of this template: Development: Strategy under construction. - Active: Available for observing. - Legacy: not offered, but still working. Obsolete: broken or succeeded by newer definitions.',
                                    on_delete=PROTECT, to='tmssapp.TemplateState'),
        ),
        migrations.AddField(
            model_name='schedulingunittemplate',
            name='purpose',
            field=models.ForeignKey(default='technical_commissioning',
                                    help_text='The purpose of this template: Production: offered to the user for cycle and DDT observations. - Scientific Commissioning: scientific/astronomical commissioning. - Technical Commissioning: technical/system commissioning. - System Health: system health monitoring.',
                                    on_delete=PROTECT, to='tmssapp.TemplatePurpose'),
        ),
        migrations.AddField(
            model_name='schedulingunittemplate',
            name='state',
            field=models.ForeignKey(default='development',
                                    help_text='The state of this template: Development: Strategy under construction. - Active: Available for observing. - Legacy: not offered, but still working. Obsolete: broken or succeeded by newer definitions.',
                                    on_delete=PROTECT, to='tmssapp.TemplateState'),
        ),
        migrations.AddField(
            model_name='subtaskfeedbacktemplate',
            name='purpose',
            field=models.ForeignKey(default='technical_commissioning',
                                    help_text='The purpose of this template: Production: offered to the user for cycle and DDT observations. - Scientific Commissioning: scientific/astronomical commissioning. - Technical Commissioning: technical/system commissioning. - System Health: system health monitoring.',
                                    on_delete=PROTECT, to='tmssapp.TemplatePurpose'),
        ),
        migrations.AddField(
            model_name='subtaskfeedbacktemplate',
            name='state',
            field=models.ForeignKey(default='development',
                                    help_text='The state of this template: Development: Strategy under construction. - Active: Available for observing. - Legacy: not offered, but still working. Obsolete: broken or succeeded by newer definitions.',
                                    on_delete=PROTECT, to='tmssapp.TemplateState'),
        ),
        migrations.AddField(
            model_name='subtasktemplate',
            name='purpose',
            field=models.ForeignKey(default='technical_commissioning',
                                    help_text='The purpose of this template: Production: offered to the user for cycle and DDT observations. - Scientific Commissioning: scientific/astronomical commissioning. - Technical Commissioning: technical/system commissioning. - System Health: system health monitoring.',
                                    on_delete=PROTECT, to='tmssapp.TemplatePurpose'),
        ),
        migrations.AddField(
            model_name='subtasktemplate',
            name='state',
            field=models.ForeignKey(default='development',
                                    help_text='The state of this template: Development: Strategy under construction. - Active: Available for observing. - Legacy: not offered, but still working. Obsolete: broken or succeeded by newer definitions.',
                                    on_delete=PROTECT, to='tmssapp.TemplateState'),
        ),
        migrations.AddField(
            model_name='systemeventtemplate',
            name='purpose',
            field=models.ForeignKey(default='technical_commissioning',
                                    help_text='The purpose of this template: Production: offered to the user for cycle and DDT observations. - Scientific Commissioning: scientific/astronomical commissioning. - Technical Commissioning: technical/system commissioning. - System Health: system health monitoring.',
                                    on_delete=PROTECT, to='tmssapp.TemplatePurpose'),
        ),
        migrations.AddField(
            model_name='systemeventtemplate',
            name='state',
            field=models.ForeignKey(default='development',
                                    help_text='The state of this template: Development: Strategy under construction. - Active: Available for observing. - Legacy: not offered, but still working. Obsolete: broken or succeeded by newer definitions.',
                                    on_delete=PROTECT, to='tmssapp.TemplateState'),
        ),
        migrations.AddField(
            model_name='taskrelationselectiontemplate',
            name='purpose',
            field=models.ForeignKey(default='technical_commissioning',
                                    help_text='The purpose of this template: Production: offered to the user for cycle and DDT observations. - Scientific Commissioning: scientific/astronomical commissioning. - Technical Commissioning: technical/system commissioning. - System Health: system health monitoring.',
                                    on_delete=PROTECT, to='tmssapp.TemplatePurpose'),
        ),
        migrations.AddField(
            model_name='taskrelationselectiontemplate',
            name='state',
            field=models.ForeignKey(default='development',
                                    help_text='The state of this template: Development: Strategy under construction. - Active: Available for observing. - Legacy: not offered, but still working. Obsolete: broken or succeeded by newer definitions.',
                                    on_delete=PROTECT, to='tmssapp.TemplateState'),
        ),
        migrations.AddField(
            model_name='tasktemplate',
            name='purpose',
            field=models.ForeignKey(default='technical_commissioning',
                                    help_text='The purpose of this template: Production: offered to the user for cycle and DDT observations. - Scientific Commissioning: scientific/astronomical commissioning. - Technical Commissioning: technical/system commissioning. - System Health: system health monitoring.',
                                    on_delete=PROTECT, to='tmssapp.TemplatePurpose'),
        ),
        migrations.AddField(
            model_name='tasktemplate',
            name='state',
            field=models.ForeignKey(default='development',
                                    help_text='The state of this template: Development: Strategy under construction. - Active: Available for observing. - Legacy: not offered, but still working. Obsolete: broken or succeeded by newer definitions.',
                                    on_delete=PROTECT, to='tmssapp.TemplateState'),
        ),
        migrations.AddField(
            model_name='reservationstrategytemplate',
            name='purpose',
            field=models.ForeignKey(default='technical_commissioning',
                                    help_text='The purpose of this template: Production: offered to the user for cycle and DDT observations. - Scientific Commissioning: scientific/astronomical commissioning. - Technical Commissioning: technical/system commissioning. - System Health: system health monitoring.',
                                    on_delete=PROTECT, to='tmssapp.TemplatePurpose'),
        ),
        migrations.AddField(
            model_name='reservationstrategytemplate',
            name='state',
            field=models.ForeignKey(default='development',
                                    help_text='The state of this template: Development: Strategy under construction. - Active: Available for observing. - Legacy: not offered, but still working. Obsolete: broken or succeeded by newer definitions.',
                                    on_delete=PROTECT, to='tmssapp.TemplateState'),
        ),
        migrations.AddField(
            model_name='schedulingsetstrategytemplate',
            name='purpose',
            field=models.ForeignKey(default='technical_commissioning',
                                    help_text='The purpose of this template: Production: offered to the user for cycle and DDT observations. - Scientific Commissioning: scientific/astronomical commissioning. - Technical Commissioning: technical/system commissioning. - System Health: system health monitoring.',
                                    on_delete=PROTECT, to='tmssapp.TemplatePurpose'),
        ),
        migrations.AddField(
            model_name='schedulingsetstrategytemplate',
            name='state',
            field=models.ForeignKey(default='development',
                                    help_text='The state of this template: Development: Strategy under construction. - Active: Available for observing. - Legacy: not offered, but still working. Obsolete: broken or succeeded by newer definitions.',
                                    on_delete=PROTECT, to='tmssapp.TemplateState'),
        ),
        migrations.AddField(
            model_name='schedulingunitobservingstrategytemplate',
            name='purpose',
            field=models.ForeignKey(default='technical_commissioning',
                                    help_text='The purpose of this template: Production: offered to the user for cycle and DDT observations. - Scientific Commissioning: scientific/astronomical commissioning. - Technical Commissioning: technical/system commissioning. - System Health: system health monitoring.',
                                    on_delete=PROTECT, to='tmssapp.TemplatePurpose'),
        ),
        migrations.AddField(
            model_name='schedulingunitobservingstrategytemplate',
            name='state',
            field=models.ForeignKey(default='development',
                                    help_text='The state of this template: Development: Strategy under construction. - Active: Available for observing. - Legacy: not offered, but still working. Obsolete: broken or succeeded by newer definitions.',
                                    on_delete=PROTECT, to='tmssapp.TemplateState'),
        ),
    ]
