# Generated by Django 3.0.9 on 2022-06-23 14:42

import django.contrib.postgres.fields
from django.db import migrations, models
import django.db.models.deletion

from lofar.sas.tmss.tmss.tmssapp.populate import populate_choices_subsystem_status

class Migration(migrations.Migration):

    dependencies = [
        ('tmssapp', '0034_patches'),
    ]

    operations = [
        migrations.CreateModel(
            name='SubsystemStatus',
            fields=[
                ('value', models.CharField(max_length=128, primary_key=True, serialize=False, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Subsystem',
            fields=[
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('description', models.CharField(blank=True, default='', help_text='A longer description of this object.', max_length=255)),
                ('name', models.CharField(help_text='Human-readable name of this object.', max_length=128, primary_key=True, serialize=False)),
                ('status', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='tmssapp.SubsystemStatus')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.RunPython(populate_choices_subsystem_status)
    ]
