from django.db import migrations, models
import django.db.models.deletion
from lofar.sas.tmss.tmss.tmssapp.populate import populate_task_schedulingunit_choices


class Migration(migrations.Migration):

    dependencies = [
        ('tmssapp', '0042_schedulingunitblueprint_placed'),
    ]

    operations = [
        # the following migration step alters the tmssapp_block_scheduling_unit_blueprint_immutable_fields_update trigger function from 0024_patches.py
        # yes, this is ugly/annoying that we have to replicate code, but that's how database migration steps/deltas/patches work...
        migrations.RunSQL('''CREATE OR REPLACE FUNCTION tmssapp_block_scheduling_unit_blueprint_immutable_fields_update()
                          RETURNS trigger AS
                          $BODY$
                          BEGIN
                            IF OLD.specifications_template_id <> NEW.specifications_template_id OR
                               OLD.name <> NEW.name OR
                               OLD.description <> NEW.description OR
                               OLD.draft_id <> NEW.draft_id OR
                               (OLD.ingest_permission_granted_since IS NOT NULL AND OLD.ingest_permission_granted_since <> NEW.ingest_permission_granted_since) OR
                               OLD.ingest_permission_required <> NEW.ingest_permission_required OR
                               OLD.piggyback_allowed_tbb <> NEW.piggyback_allowed_tbb OR
                               OLD.piggyback_allowed_aartfaac <> NEW.piggyback_allowed_aartfaac THEN
                              RAISE EXCEPTION 'ILLEGAL UPDATE OF IMMUTABLE BLUEPRINT FIELD';
                            END IF;
                            IF (OLD.scheduling_constraints_template_id <> NEW.scheduling_constraints_template_id OR
                                OLD.scheduling_constraints_doc <> NEW.scheduling_constraints_doc) AND
                                OLD.status_id NOT IN ('defined', 'schedulable', 'unschedulable', 'scheduled') THEN
                              RAISE EXCEPTION 'ILLEGAL UPDATE OF IMMUTABLE scheduling_constraints FIELD for status=%', OLD.status_id;
                            END IF;
                          RETURN NEW;
                          END;
                          $BODY$
                          LANGUAGE plpgsql VOLATILE;
                          DROP TRIGGER IF EXISTS tmssapp_block_scheduling_unit_blueprint_immutable_fields_update ON tmssapp_SchedulingUnitBlueprint ;
                          CREATE TRIGGER tmssapp_block_scheduling_unit_blueprint_immutable_fields_update
                          BEFORE UPDATE ON tmssapp_SchedulingUnitBlueprint
                          FOR EACH ROW EXECUTE PROCEDURE tmssapp_block_scheduling_unit_blueprint_immutable_fields_update();
                          ''')             
             
    ]
