# Generated by Django 3.0.9 on 2023-09-19 11:20

import django.contrib.postgres.fields.jsonb
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    dependencies = [
        ('tmssapp', '0048_indices'),
    ]

    operations = [
        migrations.CreateModel(
            name='CycleReport',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('cycle', models.OneToOneField(help_text='Cycle to which these quota apply.', on_delete=django.db.models.deletion.PROTECT, related_name='report', to='tmssapp.Cycle')),
                ('data', django.contrib.postgres.fields.jsonb.JSONField(help_text='The report data')),
                ('start', models.DateTimeField(help_text='Moment at which the reporting period starts.')),
                ('stop', models.DateTimeField(help_text='Moment at which the reporting period ends.')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
            ],
        ),
        migrations.AddConstraint(
            model_name='cyclereport',
            constraint=models.UniqueConstraint(fields=('cycle', 'start', 'stop'),
                                               name='cyclereport_unique_cycle_start_stop'))
    ]
