"""
This file contains the viewsets (based on the elsewhere defined data models and serializers)
"""

from django.shortcuts import get_object_or_404
from .lofar_viewset import LOFARViewSet
from .specification import NumberInFilter
from .. import models
from .. import serializers
from django_filters import rest_framework as filters

# Don't use Ordering class from the django_filters but use rest_framework instead !!
from rest_framework.filters import OrderingFilter
from drf_yasg import openapi
from drf_yasg.utils import swagger_auto_schema
from drf_yasg.inspectors import SwaggerAutoSchema
from drf_yasg.openapi import Parameter

from lofar.sas.tmss.tmss.tmssapp.viewsets.lofar_viewset import LOFARViewSet
from lofar.sas.tmss.tmss.tmssapp import models
from lofar.sas.tmss.tmss.tmssapp import serializers

class TemplateStateViewSet(LOFARViewSet):
    queryset = models.TemplateState.objects.all()
    serializer_class = serializers.TemplateStateSerializer


class TemplatePurposeViewSet(LOFARViewSet):
    queryset = models.TemplatePurpose.objects.all()
    serializer_class = serializers.TemplatePurposeSerializer


