# Generated by Django 3.0.9 on 2021-09-13 13:39

from django.db import migrations, models
import django.db.models.deletion
import lofar.sas.tmss.tmss.tmssapp.models.common


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('viewflow', '0008_jsonfield_and_artifact'),
        ('tmssapp', '0002_populate'),
    ]

    operations = [
        migrations.CreateModel(
            name='DecideAcceptance',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('sos_accept_after_pi', models.BooleanField(default=False)),
            ],
            bases=(models.Model, lofar.sas.tmss.tmss.tmssapp.models.common.ProjectPropertyMixin),
        ),
        migrations.CreateModel(
            name='PIVerification',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('pi_report', models.TextField()),
                ('pi_accept', models.BooleanField(default=False)),
            ],
            bases=(models.Model, lofar.sas.tmss.tmss.tmssapp.models.common.ProjectPropertyMixin),
        ),
        migrations.CreateModel(
            name='QAReportingSOS',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('sos_report', models.TextField()),
                ('quality_within_policy', models.BooleanField(default=False)),
                ('sos_accept_show_pi', models.BooleanField(default=False)),
            ],
            bases=(models.Model, lofar.sas.tmss.tmss.tmssapp.models.common.ProjectPropertyMixin),
        ),
        migrations.CreateModel(
            name='QAReportingTO',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('operator_report', models.TextField()),
                ('operator_accept', models.BooleanField(default=False)),
            ],
            bases=(models.Model, lofar.sas.tmss.tmss.tmssapp.models.common.ProjectPropertyMixin),
        ),
        migrations.CreateModel(
            name='SchedulingUnitTask',
            fields=[
                ('task_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='viewflow.Task')),
            ],
            options={
                'abstract': False,
            },
            bases=('viewflow.task', lofar.sas.tmss.tmss.tmssapp.models.common.ProjectPropertyMixin),
        ),
        migrations.CreateModel(
            name='UnpinData',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('unpin_data', models.BooleanField(default=False)),
            ],
            bases=(models.Model, lofar.sas.tmss.tmss.tmssapp.models.common.ProjectPropertyMixin),
        ),
        migrations.CreateModel(
            name='SchedulingUnitProcess',
            fields=[
                ('process_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='viewflow.Process')),
                ('decide_acceptance', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='workflowapp.DecideAcceptance')),
                ('pi_verification', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='workflowapp.PIVerification')),
                ('qa_reporting_sos', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='workflowapp.QAReportingSOS')),
                ('qa_reporting_to', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='workflowapp.QAReportingTO')),
                ('su', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='tmssapp.SchedulingUnitBlueprint')),
            ],
            options={
                'abstract': False,
            },
            bases=('viewflow.process', lofar.sas.tmss.tmss.tmssapp.models.common.ProjectPropertyMixin),
        ),
    ]
