from rest_framework.serializers import CharField, EmailField, ModelSerializer
from lofar.sas.tmss.tmss.workflowapp import models

#Viewsets and serializers to access intermediate steps of the QA Workflow
#through DRF
class QAReportingTOSerializer(ModelSerializer):
  class Meta:
    model = models.QAReportingTO
    fields = '__all__'
  
class QAReportingSOSSerializer(ModelSerializer):
  class Meta:
    model = models.QAReportingSOS
    fields = '__all__'

class PIVerificationSerializer(ModelSerializer):
  class Meta:
    model = models.PIVerification
    fields = '__all__'

class DecideAcceptanceSerializer(ModelSerializer):
  class Meta:
    model = models.DecideAcceptance
    fields = '__all__'

class SchedulingUnitProcessSerializer(ModelSerializer):
  class Meta:
      model = models.SchedulingUnitProcess
      fields = '__all__'
      
class SchedulingUnitTaskSerializer(ModelSerializer):
  owner_email = EmailField(source='owner.email', read_only=True, default=None)
  owner_username = CharField(source='owner.username', read_only=True, default=None)
  class Meta:
      model = models.SchedulingUnitTask
      fields = '__all__'

class SchedulingUnitAssignTaskSerializer(ModelSerializer):
  class Meta:
      model = models.SchedulingUnitTask
      fields = ['id','owner']

class SchedulingUnitUnassignTaskSerializer(ModelSerializer):
  class Meta:
      model = models.SchedulingUnitTask
      fields = ['id']

class SchedulingUnitGetActiveTasksSerializer(ModelSerializer):
  class Meta:
      model = models.SchedulingUnitProcess
      fields = ['id']

      