# Production deployment files for TMSS

Deployment is orchestrated by running docker-compose on the target host. Only
this `deploy` directory needs to be migrated to the target host prior to
deployment.

Below is an overview of the deployment structure / strategy across various
services (2023-03-15):

![../doc/img/lofar-deployment.png](../doc/img/lofar-deployment.png)

- [Security](#security)
- [Service names](#service-names)
- [Accessing log files](#accessing-log-files)

## Security

Configuration for services is populated through environment files and
variables. The docker images built with compose in directory should never be
published as they contain the configuration to reach / access systems.

## Service names

The TMSS containers use fixed names of the pattern `tmss_xxx` while the
docker-compose service names omit this `tmss_` prefix.

## Accessing log files

Log files are flushed to journald so we can ensure they are persistent when
docker services are upgraded. To access the logs of any particular service
use: `journalctl -u docker CONTAINER_TAG=tmss_xxx`

```shell
journalctl -u docker CONTAINER_TAG=tmss_feedback
```

The advantange of journald is that the docker engine can still access the logs
through `docker logs` as well:

```shell
docker logs tmss_feedback
```