#!/bin/bash

# Base image for two-step docker-compose image generation
echo "SOURCE_IMAGE=${SOURCE_IMAGE}" > tmss/.env
echo "SOURCE_IMAGE=${SOURCE_IMAGE}" > lobster/.env

echo "export LTA_HOST=${LTA_HOST}" > app/.env
echo "export LTA_USER=${LTA_USER}" >> app/.env
echo "export LTA_PASSWORD=${LTA_PASSWORD}" >> app/.env
echo "export LTA_TYPE=${LTA_TYPE}" >> app/.env
echo "export LTA_PORT=${LTA_PORT}" >> app/.env
echo "export LTA_DATABASE=${LTA_DATABASE}" >> app/.env
echo "export RABBITMQ_USER=${RABBITMQ_USER}" >> app/.env
echo "export RABBITMQ_PASSWORD=${RABBITMQ_PASSWORD}" >> app/.env
echo "export TMSS_HOST=${TMSS_HOST}" >> app/.env
echo "export TMSS_USER=${TMSS_USER}" >> app/.env
echo "export TMSS_PASSWORD=${TMSS_PASSWORD}" >> app/.env
echo "export TMSS_TYPE=${TMSS_TYPE}" >> app/.env
echo "export TMSS_PORT=${TMSS_PORT}" >> app/.env
echo "export TMSS_DATABASE=${TMSS_DATABASE}" >> app/.env
echo "export TMSS_CLIENT_HOST=${TMSS_CLIENT_HOST}" >> app/.env
echo "export TMSS_CLIENT_USER=${TMSS_CLIENT_USER}" >> app/.env
echo "export TMSS_CLIENT_PASSWORD=${TMSS_CLIENT_PASSWORD}" >> app/.env
echo "export TMSS_CLIENT_TYPE=${TMSS_CLIENT_TYPE}" >> app/.env
echo "export TMSS_CLIENT_PORT=${TMSS_CLIENT_PORT}" >> app/.env
echo "export TMSS_CLIENT_DATABASE=${TMSS_CLIENT_DATABASE}" >> app/.env
echo "export TMSS_SLACK_HOST=${TMSS_SLACK_HOST}" >> app/.env
echo "export TMSS_SLACK_USER=${TMSS_SLACK_USER}" >> app/.env
echo "export TMSS_SLACK_PASSWORD=${TMSS_SLACK_PASSWORD}" >> app/.env
echo "export TMSS_SLACK_TYPE=${TMSS_SLACK_TYPE}" >> app/.env
echo "export TMSS_SLACK_PORT=${TMSS_SLACK_PORT}" >> app/.env
echo "export TMSS_SLACK_DATABASE=${TMSS_SLACK_DATABASE}" >> app/.env

# Environment variables required by processes in containers
for folder in lobster tmss
do
  echo "LOFARENV=${LOFARENV}" > ${folder}/env
  # tmss django settings
  echo "DEBUG=${DEBUG}" >> ${folder}/env
  echo "ALLOWED_HOSTS=${ALLOWED_HOSTS}" >> ${folder}/env
  echo "SECRET_KEY=${SECRET_KEY}" >> ${folder}/env
  echo "TMSS_ENABLE_VIEWFLOW=${TMSS_ENABLE_VIEWFLOW}" >> ${folder}/env
  echo "TMSS_LOGOUT_REDIRECT_URL=${TMSS_LOGOUT_REDIRECT_URL}" >> ${folder}/env

  # RabbitMQ and lofar usage of rabbitmq
  echo "RABBITMQ_DEFAULT_USER=${RABBITMQ_DEFAULT_USER}" >> ${folder}/env
  echo "RABBITMQ_DEFAULT_PASS=${RABBITMQ_DEFAULT_PASS}" >> ${folder}/env
  echo "RABBITMQ_DEFAULT_PORT=${RABBITMQ_DEFAULT_PORT}" >> ${folder}/env
  echo "LOFAR_DEFAULT_BROKER=${LOFAR_DEFAULT_BROKER}" >> ${folder}/env
  echo "LOFAR_DEFAULT_EXCHANGE=${LOFAR_DEFAULT_EXCHANGE}" >> ${folder}/env

  # Keycloak user authentication
  echo "OIDC_RP_CLIENT_ID=${OIDC_RP_CLIENT_ID}" >> ${folder}/env
  echo "OIDC_RP_CLIENT_SECRET=${OIDC_RP_CLIENT_SECRET}" >> ${folder}/env
  echo "OIDC_OP_JWKS_ENDPOINT=${OIDC_OP_JWKS_ENDPOINT}" >> ${folder}/env
  echo "OIDC_OP_AUTHORIZATION_ENDPOINT=${OIDC_OP_AUTHORIZATION_ENDPOINT}" >> ${folder}/env
  echo "OIDC_OP_TOKEN_ENDPOINT=${OIDC_OP_TOKEN_ENDPOINT}" >> ${folder}/env
  echo "OIDC_OP_USER_ENDPOINT=${OIDC_OP_USER_ENDPOINT}" >> ${folder}/env
  echo "OIDC_ENDPOINT_HOST=${OIDC_ENDPOINT_HOST}" >> ${folder}/env
  echo "KEYCLOAK_TOKEN_URL=${KEYCLOAK_TOKEN_URL}" >> ${folder}/env
  echo "KEYCLOAK_ADMIN_USER=${KEYCLOAK_ADMIN_USER}" >> ${folder}/env
  echo "KEYCLOAK_ADMIN_PASSWORD=${KEYCLOAK_ADMIN_PASSWORD}" >> ${folder}/env
  echo "KEYCLOAK_API_BASE_URL=${KEYCLOAK_API_BASE_URL}" >> ${folder}/env

  # fallback for non-keycloak users (like admin etc)
  echo "LDAP_SERVER_URI=${LDAP_SERVER_URI}" >> ${folder}/env
done