import React, {Component} from 'react';
import PropTypes from 'prop-types';

/**
 * Component to get input for Resource allocation while creating and editing Project
 */
class ResourceDisplayList extends Component {
    constructor(props) {
        super(props);
        this.state = {
            quota: props.quota
        }
    }

    render(){
        return (
            <>
                {this.props.quota.length>0 && this.props.quota.map((item ) => (
                    <React.Fragment key={item.resource.name}>
                    <label key={'label1-'+ item.resource.name} className="col-lg-3 col-md-2 col-sm-12">{item.resource.name}</label>
                    <span key={'div1-'+ item.resource.name} data-testid={item.resource.name} className="col-lg-3 col-md-4 col-sm-12">
                        {item.value/(this.props.unitMap[item.resource.quantity_value]?this.props.unitMap[item.resource.quantity_value].conversionFactor:1)}
                        {` ${this.props.unitMap[item.resource.quantity_value]?this.props.unitMap[item.resource.quantity_value].display:''}`}
                    </span>
                    </React.Fragment>
                ))}
            </>
        );
    }
}

ResourceDisplayList.propTypes = {
  quota: PropTypes.array,
  unitMap: PropTypes.any
}

export default ResourceDisplayList;