import { Component } from 'react';
import PropTypes from 'prop-types';

import { withRouter } from 'react-router-dom';
import AppSubmenu from './AppSubMenu'

export class AppMenu extends Component {

    static defaultProps = {
        model: null,
        onMenuItemClick: null
    }



    render() {
        return (
            <div className={'layout-sidebar layout-sidebar-light'} >
                <div className="layout-menu-container">
                    <AppSubmenu toggleDirtyDialog={this.props.toggleDirtyDialog} isEditDirty={this.props.isEditDirty} history={this.props.history} items={this.props.model} className="layout-menu" onMenuItemClick={this.props.onMenuItemClick} root={true}/>
             
                </div>
            </div>
        );
    }
}
AppMenu.propTypes = {
  toggleDirtyDialog: PropTypes.func,
  isEditDirty: PropTypes.bool,
  history: PropTypes.object,
  model: PropTypes.array,
  onMenuItemClick: PropTypes.func
}
export default withRouter(AppMenu)