import CycleReportMain from "./report.main"
import renderer, { act } from 'react-test-renderer';
import listCycle from './testdata/test.cycle.expand.json'
import axios from "axios";
import MockAdapter from 'axios-mock-adapter';


function MakePrimaryMock() {
    let mock = new MockAdapter(axios);
        mock.onGet("/api/cycle?expand=quota").reply(200, listCycle);
}
describe('Render Contents', () => {
    it("renders without errors without data", () => {
        const page = renderer
            .create(<CycleReportMain> </CycleReportMain>)
            .toJSON();
        expect(page).toMatchSnapshot();
    });

    it('renders correctly with data', async () => {
        MakePrimaryMock();

        let page;
        await act(async () => {
            page = renderer
                .create(<CycleReportMain> </CycleReportMain>);
        });

        // Now `page` should be defined
        expect(page.toJSON()).toMatchSnapshot();
    });
});
