import { InputSwitch } from "primereact/inputswitch"
import PropTypes from 'prop-types';
export default  function Toggle(props) { 
    const {
        labelName,
        tooltipText,
        checkedValue,
        onChangeCallback,
    } = props

    if (checkedValue === undefined || onChangeCallback === undefined) {
        return null
    }

    return <div className={`toggle-container ${checkedValue ? "" : "disabled"}`}>
        <label>{labelName}</label>
        <InputSwitch checked={checkedValue}
            tooltip={tooltipText}
            onChange={(e) => onChangeCallback(e.value)
            } />
    </div>
}

Toggle.propTypes = {
  labelName: PropTypes.string,
  tooltipText: PropTypes.string,
  checkedValue: PropTypes.bool,
  onChangeCallback: PropTypes.func.isRequired
}