
import { MockAxiosSecurity,MockAxiosBadSecurity } from "../../tests/axiosmocks.";
import { remove404Errors } from "../../utils/test.helper";
import UserOverView from "./UserOverView"
import renderer, { act } from 'react-test-renderer';





describe('UserOverView Render Contents', () => {
    it("UserOverView renders without errors without data", () => {
        remove404Errors();
        const page = renderer
            .create(<UserOverView> </UserOverView>)
            .toJSON();
        expect(page).toMatchSnapshot();
    });

    it('UserOverView renders correctly with data', async () => {
      MockAxiosSecurity();

        let page;
        await act(async () => {
            page = renderer
                .create(<UserOverView> </UserOverView>);
        });

        // Now `page` should be defined
        expect(page.toJSON()).toMatchSnapshot();
    });


    it('UserOverView renders correctly with Server Error', async () => {
        remove404Errors();
        MockAxiosBadSecurity();
          let page;
          await act(async () => {
              page = renderer
                  .create(<UserOverView> </UserOverView>);
          });
  
          // Now `page` should be defined
          expect(page.toJSON()).toMatchSnapshot();
      });


      
});
