import moment from "moment";
import TimelineItemPopover from "../routes/Timeline/components/TimelineItemPopover";

describe('TimeLineItem PopOver', () => {
    
    
    
    it('TimeLineItem PopOver  renders correctly Schedule', async () => {
       let schedule = {  mouseOverItem : { id:"One", type:"SCHEDULE",name:"sname",schedular:"schedular-Fixed",antenna_set:"Antennaset","Stations":"Stations Here",status:"Status Here",Duration:"1H",real_start_time:"12:40",real_end_time:"13:40"}}
       expect(TimelineItemPopover(schedule)).toMatchSnapshot("SCHEDULE")
       schedule.mouseOverItem.status="unschedulable"
       schedule.mouseOverItem.suId="Two"
       schedule.mouseOverItem.task={name:"Task Name"}
       expect(TimelineItemPopover(schedule)).toMatchSnapshot("SCHEDULE with SUID and unscheduble with Project")
    });

    it('TimeLineItem PopOver  renders correctly Reservation', async () => {

        
        let reservation = {  mouseOverItem : { type:"RESERVATION",id:"reservation",description:"A description",Stations:"Some Stations",real_start_time:"10:00",real_end_time:"12:00",Duration:"1D",planned:true}}
        expect(TimelineItemPopover(reservation)).toMatchSnapshot("RESERVATION")
        reservation.mouseOverItem.planned=false;
        reservation.mouseOverItem.project="A Project";
        expect(TimelineItemPopover(reservation)).toMatchSnapshot("RESERVATION not planned with project")

        
    });

    it('TimeLineItem PopOver  renders correctly SunTime', async () => {
        expect(TimelineItemPopover({  mouseOverItem : { type:"SUNTIME",id:"sunrise_tst"}})).toMatchSnapshot("SunTime SunRise")
        expect(TimelineItemPopover({  mouseOverItem : { type:"SUNTIME",id:"sunset_tst" , start_time: moment(new Date(2000, 0, 1, 1)) , end_time:moment(new Date(2000, 0, 1, 2))}})).toMatchSnapshot("SunTime Sunset")
        expect(TimelineItemPopover({  mouseOverItem : { type:"SUNTIME",id:"nosunrise_tst"}})).toMatchSnapshot("No SunRise")
        
    });

    it('TimeLineItem PopOver  renders correctly wrong type', async () => {
        TimelineItemPopover({  mouseOverItem : { type:"non existing"}})
    });


    it('TimeLineItem PopOver  renders correctly emptyness', async () => {
        TimelineItemPopover({ })
    });

    it('TimeLineItem PopOver  Error Parsing', async () => {
        expect(TimelineItemPopover({  mouseOverItem : { type:"SUNTIME",id:"sunset_tst" , start_time: "10:20", end_time:"14:20"}})).toMatchSnapshot("SunTime Sunset")
    });

    

});
