import AuthStore from "../authenticate/auth.store";
import PermissionStackUtil from "../authenticate/permission.stack.handler";

const AuthUtil = {
    getUserRolePermission : async function() {
        return AuthStore.getState();
    },
    getUserPermissionByModule: module => {
        const allPermissions = AuthStore.getState();
        let modulePermissions = {}
        modulePermissions[module] = allPermissions.userRolePermission[module];
        return modulePermissions?modulePermissions:{};
    },

    getUserPermissionByModuleId: async (module, id) => {
        const allPermissions = AuthStore.getState();
        let modulePermissions ={};
        modulePermissions = allPermissions.userRolePermission.rolePermission && allPermissions.userRolePermission.rolePermission[module] ? allPermissions.userRolePermission.rolePermission[module]:{};
        if(modulePermissions[id]) {
            return modulePermissions;
        }
        else {
            modulePermissions = await PermissionStackUtil.getAccessByModuleAndId(module, id);
            return modulePermissions;
        }
    }
};

export default AuthUtil;