const UIConstants = {
    TIMINGSERVER :"CS002",
    tooltipOptions: {position: 'left', event: 'hover', className: "p-tooltip-custom"},
    timeline: {
        types: {NORMAL: "NORMAL", WEEKVIEW: "WEEKVIEW"}
    },
    httpStatusMessages: {
        400: {
            severity: 'error',
            summary: 'Error',
            sticky: true,
            detail: 'Request data may be incorrect. Please try again or contact system admin'
        },
        401: {
            severity: 'error',
            summary: 'Error',
            sticky: true,
            detail: 'Not authenticated, please login with valid credential'
        },
        403: {
            severity: 'error',
            summary: 'Error',
            sticky: true,
            detail: "You don't have permissions to this action, please contact system admin"
        },
        404: {
            severity: 'error',
            summary: 'Error',
            sticky: true,
            detail: 'URL is not recognized, please contact system admin'
        },
        408: {
            severity: 'error',
            summary: 'Error',
            sticky: true,
            detail: 'Request is taking more time to response, please try again or contact system admin'
        },
        500: {
            severity: 'error',
            summary: 'Error',
            sticky: true,
            detail: 'Server could not process the request, please check the data submitted is correct or contact system admin'
        },
        503: {
            severity: 'error',
            summary: 'Error',
            sticky: true,
            detail: 'Server is not available, please try again or contact system admin'
        },
    },
    CALENDAR_DATE_FORMAT: 'yy-mm-dd',
    CALENDAR_DATETIME_FORMAT: 'YYYY-MM-DD HH:mm:ss',
    CALENDAR_TIME_FORMAT: 'HH:mm:ss',
    CALENDAR_DEFAULTDATE_FORMAT: 'YYYY-MM-DD',
    UTC_DATE_TIME_FORMAT: "YYYY-MM-DDTHH:mm:ss",
    UTC_DATE_TIME_MS_FORMAT: "YYYY-MM-DDTHH:mm:ss.SSSSS",
    CALENDAR_GROUP_FORMAT: "w: MMM DD - ddd",
    CALENDAR_GROUPING_FORMAT:"YYYY_MM_DD",
    FILTER_MAP: {
        'AutoField': '',
        'CharFilter': '',
        'ForeignKey': '',
        'DateTimeFilter': 'fromdatetime',
        'BooleanFilter': 'switch',
        'ModelChoiceFilter': 'select',
        'NumberFilter': '',
        'PropertyIsoDateTimeFromToRangeFilter': '',
    },
    SU_STATUS: ['cancelled', 'error', 'defining', 'defined', 'schedulable', 'scheduled', 'started', 'observing', 'observed', 'processing', 'processed', 'ingesting', 'finished', 'unschedulable'],
    CURRENT_WORKFLOW_STAGE: ['Waiting To Be Scheduled', 'Scheduled', 'QA Reporting (TO)', 'QA Reporting (SDCO)', 'PI Verification', 'Decide Acceptance', 'Ingesting', 'Unpin Data', 'Done'],
    SU_PRIORITY_QUEUE: ['A', 'B'],
    TARGET_OBSERVATION_NAMES: ['target observation', 'parallel calibrator target and beamforming observation',
        'parallel target and beamforming observation', 'parallel calibrator target observation', 'beamforming observation'],
    SU_NOT_STARTED_STATUSES: ['defined', 'schedulable', 'scheduled', 'unschedulable'],
    SU_ACTIVE_STATUSES: ['started', 'observing', 'observed', 'processing', 'processed', 'ingesting', 'ingested'],
    STORE_KEY_TIMELINE: "TIMELINE_UI_ATTR",
    WEEKVIEW_SHOW_NUMBER_OF_DAYS: 6,
    ALL_ZOOM_LEVELS_WEEK: [{name: '30 Minutes', days: 0, hours: 0, minutes: 30},
        {name: '1 Hour', days: 0, hours: 1, minutes: 0},
        {name: '3 Hours', days: 0, hours: 3, minutes: 0},
        {name: '6 Hours', days: 0, hours: 6, minutes: 0},
        {name: '12 Hours', days: 0, hours: 12, minutes: 0},
        {name: '1 Day', days: 1, hours: 0, minutes: 0}],
    ALL_ZOOM_LEVELS: [{name: '30 Minutes', days: 0, hours: 0, minutes: 30},
        {name: '1 Hour', days: 0, hours: 1, minutes: 0},
        {name: '3 Hours', days: 0, hours: 3, minutes: 0},
        {name: '6 Hours', days: 0, hours: 6, minutes: 0},
        {name: '12 Hours', days: 0, hours: 12, minutes: 0},
        {name: '1 Day', days: 1, hours: 0, minutes: 0},
        {name: '2 Days', value: 2 * 24 * 60 * 60},
        {name: '3 Days', value: 3 * 24 * 60 * 60},
        {name: '5 Days', value: 5 * 24 * 60 * 60},
        {name: '5 Days', value: 5 * 24 * 60 * 60},
        {name: '1 Week', value: 7 * 24 * 60 * 60},
        {name: '2 Weeks', value: 14 * 24 * 60 * 60},
        {name: '4 Weeks', value: 28 * 24 * 60 * 60},
        {name: 'Custom', value: 24 * 60 * 60}],
    ALL_TIMESTEPS: [
        {
            name: '1 Hour', value: {
                minute: 0,
                hour: 1,
            }
        },
        {
            name: '2 Hours', value: {
                minute: 0,
                hour: 2,
            }
        },
        {
            name: '3 Hours', value: {
                minute: 0,
                hour: 3,
            }
        },
        {
            name: '30 Minutes', value: {
                minute: 30,
                hour: 0,
            }
        },
        {
            name: '10 Minutes', value: {
                minute: 10,
                hour: 0,
            }
        },
        {
            name: '5 Minutes', value: {
                minute: 5,
                hour: 0,
            }
        },
        {
            name: '1 Minute', value: {
                minute: 1,
                hour: 0,
            }
        },
    ],
    DEFAULT_ZOOM_LEVEL: {name: '1 Day', days: 1, hours: 0, minutes: 0},
    LEGEND_INFO: [
        {
            title: "Status",
            elements: [
                {classKey: "su-defined", value: "Defined"},
                {classKey: "su-schedulable", value: "Schedulable"},
                {classKey: "su-scheduled", value: "Scheduled"},
                {classKey: "su-queued", value: "Queued"}
            ]
        },
        {
            title: "Active",
            elements: [{classKey: "su-started", value: "Started"},
                {classKey: "su-observing", value: "Observing"},
                {classKey: "su-processing", value: "Processing"},
                {classKey: "su-ingesting", value: "Ingesting"}
            ]
        },
        {
            title: "Success",
            elements: [{classKey: "su-processed", value: "Processed"},
                {classKey: "su-observed", value: "Observed"},
                {classKey: "su-ingested", value: "Ingested"},
                {classKey: "su-finished", value: "Finished"}
            ]
        },
        {
            title: "Fail",
            elements: [{classKey: "su-cancelled", value: "Cancelled"},
                {classKey: "su-error", value: "Error"},
                {classKey: "su-unschedulable", value: "Unschedulable"}
            ]
        },
        {
            title: "Station",
            subtitle: "Station Reservation",
            elements: [{classKey: "reserve-not-available", value: "N/A", title: "Not Available"},
                {classKey: "reserve-available", value: "Available"},
                {classKey: "reserve-fixed_time", value: "Fixed Time"},
                {classKey: "reserve-dynamic", value: "Dynamic"}
            ]
        },
        {
            title: "Indicators",
            subtitle: "Indication about the settings",
            elements: [{classKey: "su-fixed_time", value: "Fixed Time"},
                {classKey: "su-dynamic", value: "Dynamic"},
                {classKey: "su-unplaced", value: "Unplaced"}
            ]
        },
        {
            title: "Sunturn",
            elements: [{classKey: "legend-sunrise", value: "Sunrise"},
                {classKey: "legend-sunset", value: "Sunset"},
                {classKey: "legend-night", value: "Night"}
            ]
        }],
    //The size roughly indicates the percentage of the screen it uses. Steps between sizes need to be 10%
    PANEL_SIZE_CLASS_MAP: [
        {size: 0, left: 0, right: 0},
        {size: 10, left: 2, right: 3},
        {size: 20, left: 3, right: 0},
        {size: 30, left: 4, right: 0},
        {size: 40, left: 5, right: 0},
    ],
}
export default UIConstants;